c THE PTOT ARRAYS ARE REDUNDANT AND SHOULD BE DELETED, the only
c variables used from these arrays are ptot(1) -> total number of 
c moles of the components per unit system, and ptot(2) -> the 
c molar weight per unit system.

c physical property arrays in plib.f routines:

c the basic properties from vertex are in the arrays props, ptot, ptot1

c props(np,k5,k2) for the k5'th compund of the k2'th assemblage,
c np is the physical property as follows:

c    1 - molar proportion
c    2 - atwt (g)
c    3 - molar enthalpy (J)
c    4 - volume (J/bar)
c    5 - Cp (J/K)
c    6 - dV/dT (J/bar/K)
c    7 - dV/dP (J/bar/bar)
c    8 - d2V/dT2
c    9 - (dV/dT)/dP
c   10 - d2V/dP2
c   11 - S (J/K) replaced d3V/dT3 as of 5/31/04
c   12 - shear modulus
c   13 - temperature derivative of the shear modulus
c   14 - pressure derivative of the shear modulus

c iflu(k2) = 1 if fluid present, otherwise = 0.

c additionally we have the following proportions and bulk properties:

c  ptot(1,k2)  - aggregate total moles
c  ptot(2,k2)  - aggregate total weight

c  ptot1(1,k2) - aggregate-fluid total moles
c  ptot1(2,k2) - aggregate-fluid total weight


c from these routine seismo computes the following properties as 
c a function of pressure and temperature:

c in array pphi(j,k5) for each cpd:

c 1 - vphi(k5)   - cpd volume 
c 2 - ephi(k5)   - cpd enthalpy 
c 3 - grunp(k5)  - cpd gruenesien ratio
c 4 - bulkmp(k5) - cpd adiabatic bulk modulus
c 5 - mup(k5)    - cpd shear modulus
c 6 - vel0p(k5)  - cpd sound velocity 
c 7 - velsp(k5)  - cpd s-wave velocity
c 8 - velpp(k5)  - cpd p-wave velocity
c 9 - vp/vs
c10 - rhop(k5)   - cpd density
c11 - vfract(k5) - cpd volume fraction
c12 - cp
c13 - alpha
c14 - beta 

c in arrays psys(j) and psys1(j)
c (vsys, esys, cp, alpha, beta, rho are calculated by arithmetic mean, the
c values of cp alpha and beta used for seismic props are computed by VRH
c averaging).

c 1 vsys       - sys molar volume 
c 2 esys       - sys molar enthalpy 
c 3 grun       - sys gruenesien ratio
c 4 bulkm      - sys adiabatic bulk modulus
c 5 mu         - sys shear modulus
c 6 vel0       - sys sound velocity 
c 7 velp       - sys p-wave velocity
c 8 vels       - sys s-wave velocity
c 9 vp/vs      
c 10 rsys      - sys density
c 11 csys      - sys specific heat capacity
c 12 cp
c 13 alpha
c 14 beta 

c additionally the total (cpd sum) for a solution can be obtained
c with routine vmodes.

	subroutine amiin (x,y,iam)

c amiin - routine to check if a (x,y) point lies inside a polygon.
c         copy of katja's check inside, assumes last point duplicates
c         first point.

c         alternatively (icopt=5) amiin identifies the assemblage 
c         associated with a grid point.

c         iam - is the polygon id if x-y is bounded otherwise 0.

      implicit real (a-g,o-z),integer (h-n)
 
      include 'perplex_parameters.h'

      parameter (l3=l2+2)

      common/ polyx /px(l5,k2)/ polyy /py(l5,k2)
     *      / poly /npts(k2),iptoa(k2),ibd(k2),npoly
     *      / cst309 /dx,dy,igrd(l7,l7),loopx,loopy
     *      / vs     /vmin(l3),vmax(l3),iv
      common/ basic  /n4,ifont,icopt,jwidth,iop0

      if (icopt.eq.5) then 
c                                     find node associated with condition
         delx = x-vmin(1)
         ix = delx/dx 
         res = delx - ix*dx
         if (res.gt.0.5*dx) ix = ix + 1
         ix = ix + 1

         dely = y-vmin(2)
         jy = dely/dy 
         res = dely - jy*dy
         if (res.gt.0.5*dy) jy = jy + 1
         jy = jy + 1

         iam = igrd(ix,jy)

         goto 99

      end if 
c                                     do for each polygon:
      do i = 1, npoly

         if (ibd(i).eq.1) then 
         
            igo = 0

            do j = 1, npts(i) - 1

               if ((y.le.py(j,i).and.y.gt.py(j+1,i)).or. 
     *             (y.gt.py(j,i).and.y.le.py(j+1,i))) then 
	 
                  if (( (py(j+1,i)-py(j,i))*(x-px(j,i))
     *                - (px(j+1,i)-px(j,i))*(y-py(j,i)) )
     *                * (py(j+1,i)-py(j,i)) .lt. 0e0) igo = iabs(igo-1)

               end if 
            end do 
c                                      odd number of flips
c                                      the point is inside
            if (igo.eq.1) then 
               iam = iptoa(i)
               goto 99
            end if 
         end if 
      end do 

      iam = 0	

99    end 

      subroutine pplinp (fname)

c pplinp - read polygon file

      implicit real (a-g,o-z),integer (h-n)
 
      character*100 fname,n5name
 
      include 'perplex_parameters.h'

      common / basic /n4,ifont,icopt,jwidth,iop0
     *       / polyx /px(l5,k2)/ polyy /py(l5,k2)
     *       / poly /npts(k2),iptoa(k2),ibd(k2),npoly

      n5 = n4 + 1
c                                    open polygon file = 'p' + plot file name.
      n5name = fname 
      call inblnk (n5name,'p')
      open (n5,file=n5name,status='old')
      read (n5,*,end=90) npoly,ncoor

      if (npoly.gt.k2) then 
         write (*,1000) npoly,k2
         stop
      else if (ncoor.gt.l5) then 
         write (*,1010) ncoor,l5
         stop
      end if 

      do i = 1, npoly
         read (n5,*,end=90) npts(i),iptoa(i),ibd(i)
         npts(i) = npts(i)/2
         read (n5,*) (px(j,i), py(j,i), j = 1, npts(i))
      end do 

      goto 99

90    write (*,1020) n5name,fname
      stop

1000  format (/,'Too many polygons (',i5,') increase parameter k2 (',
     *        i5,' and recompile WERAMI',/)
1010  format (/,'Too many coordinates in a polygon (',i5,') increase',
     *          ' parameter l5 (',i5,') and recompile WERAMI',/)
1020  format (/,'Inconsistent polygon file:',/,a,/
     *          'You have not run POLYGON since generating ',/,a,/,
     *          'with VERTEX, or POLYGON terminated abnormally.',/)
99    end 

      subroutine plinp (tmin,tmax,pmin,pmax)
 
c plinp - subroutine to read x-y plot file header.

      implicit real (a-g,o-z),integer (h-n)
 
      character*8 tname*162,vname,names,sname*10,cname*5
 
      include 'perplex_parameters.h'

      double precision dblk(3,k5)

      parameter (l3=l2+2)

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
     *      / cst319 /iemod(k2),kmod  
      common/ cst8  /names(k1)/ csta7 /sname(h9)/ phase /ikp(k1)
     *      / excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / basic /n4,ifont,icopt,jwidth,iop0
     *      / csta4 /cname(k5)/ cst20 /comps(k1,k5),atwt(k5),icomp
     *      / cst309 /dx,dy,igrd(l7,l7),loopx,loopy
     *      / cst310 /tname(4)/ cst315 /jcont/ cst321 /interp 
     *      / cst316 /c0,c1,c2,c3,c4,iind,idep

      jcont = 0 
      interp = 0
      iind = 0
      read (n4,*,err=91) icopt

      if (icopt.eq.7.or.icopt.eq.9) then 
c                               interp = 1, turn
c                               interpolation off for
c                               fractionation calcs.
         interp = 1
c         if (icopt.eq.7) icopt = 5
         icopt = 5
         write (*,3000) 

      end if 

      read (n4,*) iphct, isoct, icomp
      read (n4,*) jbulk, ivol, icp, jvol, kmod
      if (icomp.ne.0) then
         read (n4,1040) (cname(i), i = 1, icomp)
         read (n4,*) (atwt(i), i = 1, icomp)
      end if 
      if (iphct.ne.0) then
         if (iphct.gt.k1) then 
            write (*,*) '**error** too many pseudocompounds, ',
     *                  'increase parameter k1.'
            stop
         end if 
         read (n4,1010) (names(i),i = 1, iphct)
         read (n4,*) ((comps(i,j), j= 1, icomp), i = 1, iphct)
         read (n4,*) (ikp(i), i = 1, iphct)
      end if
      if (isoct.ne.0) read (n4,1030) (sname(i), i = 1, isoct) 
      read (n4,1000) tname
      read (n4,*) iv,(jv(i),i=1,iv),jpt
      read (n4,*) jcont,iind,idep,c0,c1,c2,c3,c4
      read (n4,*) (vmax(i),vmin(i),i=1,iv)
      read (n4,1000) (vname(i),i=1,iv)
c                              turn interpolation off if only
c                              compositional variables:
      if (jcont.ne.0) then 
         interp = 1
      end if 



      if (icopt.eq.5.or.icopt.eq.9) then 
c                                       compositions
         if (jcont.gt.0) read (n4,*) 
     *                   ((dblk(i,j),j=1,jbulk),i=1,jcont+1)
c                                       grid plot file
         if (icopt.eq.5) then 
            read (n4,*) loopx, loopy
         else 
            read (n4,*) loopx, loopy, zbox
         end if 

         if (loopx.eq.1) then
            write (*,1060) vmin(1)
            vmax(1) = vmin(1)+0.001
            dx = 0.002
         else 
            dx = (vmax(1) - vmin(1))/float(loopx-1)
         end if 

         if (icopt.eq.9) then 
            vmin(2) = 0d0
            vmax(2) = zbox*(loopy-1)
         end if 

         dy = (vmax(2) - vmin(2))/float(loopy-1)
c                                       decompress the grid data
         do i = 1, loopx
            jst = 1
            do while (jst.le.loopy)
               read (n4,*) irep, kd
               jend = jst + irep 
               do j = jst, jend
                  igrd(i,j) = kd
               end do 
               jst = jend + 1
            end do 
         end do 
      end if           
c                                       for polygon:
      jcopt = icopt 

      tmin = vmin(1)
      tmax = vmax(1)
      pmin = vmin(2)
      pmax = vmax(2)

      goto 99

91    write (*,1050)
      stop

1000  format (a)
1010  format (10a8)
1030  format (8a10)
1040  format (20a5)
1050  format (/,'The plot-file is not formatted correctly.',/)
1060  format (/,'**warning** you are plotting a 1-dimensional grid ',
     *        'as a 2-dimensional',/,'plot. The width of the X-axis ',
     *        'is arbitrary, the assigned value for the X-axis',/,
     *        'variable is: ',g12.6,/)
1070  format (/,'Enter the VERTEX plot file name: ')
3000  format (/,'**warning ver636** For this computational mode ',
     *          'interpolation of physical',/,'properties has been ',
     *          'turned OFF.',/)

99    end

c-------------------------------------------------------------------
      subroutine bplinp (fname,kpoly)

c subroutine to read bulk composition data file for pseudosections.

c props(np,k5,k2) for the k5'th compund of the k2'th assemblage,
c np is the physical property as follows:

c    2 - atwt (g)
c    3 - molar enthalpy (J)
c    4 - volume (J/bar)
c    5 - Cp (J/K)
c    6 - dV/dT (J/bar/K)
c    7 - dV/dP (J/bar/bar)
c    8 - dCp/dT
c    9 - dCp/dP
c   10 - d2V/dT2
c   11 - (dV/dT)/dP
c   12 - (dV/dP)/dT
c   13 - dV2/dP2
c   14 - shear modulus
c   15 - temperature derivative of the shear modulus
c   16 - pressure derivative of the shear modulus

c iflu(k2) = 1 if fluid present, otherwise = 0.

c additionally we have the following proportions and bulk properties:

c  ptot(1,k2)  - aggregate total moles
c  ptot(2,k2)  - aggregate total weight
c  ptot(4,k2)  - aggregate total volume
c  ptot1(1,k2) - aggregate-fluid total moles
c  ptot1(2,k2) - aggregate-fluid total weight
c  ptot1(4,k2) - aggregate-fluid total volume

c from these we can define 

c props(1,i,jd)/ptot(1,jd)                 - compound mol fraction 
c props(1,i,jd)*props(2,i,jd)/ptot(2,jd)   - compound wt fraction
c props(1,i,jd)*props(4,i,jd)/ptot(4,jd)   - compound volume fraction


      implicit real (a-g,o-z),integer (h-n)

      character*100 fname, n5name
 
      include 'perplex_parameters.h'

      parameter (l3=l2+2)

      common/ basic /n4,ifont,icopt,jwidth,iop0
     *      / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst81 /ptot(i8,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(i8,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst20 /comps(k1,k5),atwt(k5),icomp
     *      / vs    /vmin(l3),vmax(l3),iv/ cst315 /jcont   
     *      / cst319 /iemod(k2),kmod
     *      / cst316 /c0,c1,c2,c3,c4,iind,idep

      n5 = n4 + 1
      ibulk = 1
c                                    open assemblage information
c                                    file = 'b' + plot file name.
      n5name = fname 
      call inblnk (n5name,'b')
      open (n5,err=90,file=n5name,status='old')

10    read (n5,*,end=20) jd, ivar(ibulk), iap(ibulk), iflu(ibulk),
     *                   (idbk(i,ibulk), i = 1, jbulk)

	if (iind.eq.0) then 
         read (n5,*) (vr(i,ibulk), i = 1, iv - jcont)
	else 
         read (n5,*) (vr(i,ibulk), i = 1, iv - jcont - 1)
	end if 

      read (n5,*) ((props(j,i,ibulk), j = 1, 11), i = 1, jbulk)
      read (n5,*) (ptot(j,ibulk), j = 1, 7),btot(ibulk),gtot(ibulk),
     *            (fbulk(j,ibulk), j = 1, icomp)
      if (iflu(jd).eq.1) then 
         read (n5,*) (iflug(j,ibulk), j = 1, jbulk)
         read (n5,*) (ptot1(j,ibulk), j = 1, 7),
     *        btot1(ibulk),gtot1(ibulk),(fbulk1(j,ibulk), j = 1, icomp)
      end if 
 
      if (kmod.ne.0) then 
         read (n5,*) iemod(ibulk)
         if (iemod(ibulk).ne.0) read (n5,*) 
     *     ((props(j,i,ibulk), j= 12, 14), i = 1, jbulk)
      else 
         iemod(ibulk) = 0d0
      end if 

      ibulk = ibulk + 1
      goto 10

20    close (n5)

      ibulk = ibulk - 1
c                                    open polygon file = 'p' + plot file name.

      kpoly = ibulk 

      goto 99 

90    write (*,1000) n5name,fname
      stop

1000  format (/,'The bulk information file:',/,a,/,'corresponding to'
     *         ,' plot file:',/,a,/,'does not exist.',//)

99    end   
c-------------------------------------------------------------------
      subroutine calpr1 (x,y,jd,n3) 

c calprp - compute full vertex style print output from b-plot file.

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'
 
      character cname*5, pname(k5)*20, vname*8, cprop*18

      integer iopt

      real x, y

      parameter (l3=l2+2)

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
      common/ csta4  /cname(k5)/ cst20 /comps(k1,k5),atwt(k5),icomp
      common/ basic /n4,ifont,icopt,jwidth,iop0/ cst315 /jcont 
     *      / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst81 /ptot(i8,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(i8,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst317 /pphi(i7,k5),psys(i7),psys1(i7),sphi(i7,k5),
     *                idphi(k5),nphi
     *      / cst316 /c0,c1,c2,c3,c4,iind,idep/ opts /iopt(10)
     *      / cst324 /scomps(k5,k5),pcomp(k5,k5)
     *      / cst322 /cwt(k5),swt(k5),twt(k5)
c                                      determine if x and/or y are 
c                                      pressure or temperature:
      call xytopt (x,y,p,t,dp,dt,jd)   
c                                      compute derivative props:                                    
      call seismo (p,t,dp,dt,jd)

      write (n3,1000) jd 
      write (n3,1120) vname(1), x, vname(2), y 
      if (iv.gt.2) write (n3,1120) (vname(i), vr(i-jcont,jd), i = 3, iv)

      if (iopt(2).eq.0) then 
         cprop = 'molar  proportions'
      else
         cprop = 'weight percentages'
      end if

      write (n3,1020) cprop, (cname(i), i = 1, icomp)

      if (iopt(1).eq.0.or.iopt(1).eq.2) then 
c                                      output without averaging pseudocompounds  
         do i = 1, jbulk
            call blktxt (pname(i),idbk(i,jd),0)
            write (n3,1030) pname(i),  
     *                      props(1,i,jd)*props(2,i,jd)/ptot(2,jd)*1e2,
     *                      pphi(11,i)*1e2,(pcomp(i,l), l = 1, icomp)
         end do 

         write (n3,1160)
c                                     phase/system summary, normal thermo:
         do i = 1, jbulk
c                                     N, H, V, Cp, alpha, beta
            write (n3,1170) pname(i), props(2,i,jd),pphi(2,i),pphi(1,i),
     *                     (pphi(j,i), j = 12, 14), pphi(10,i)
         end do

         write (n3,1170) 'System              ',ptot(2,jd),psys(2),
     *                psys(1),psys(12),psys(13),psys(14)

         if (iflu(jd).eq.1) 
     *   write (n3,1170) 'System - Fluid      ',ptot1(2,jd),psys1(2),
     *                   psys1(1),psys1(12),psys1(13),psys1(14)

         write (n3,1190)
c                                     phase/system summary, seismic:
         do i = 1, jbulk
            write (n3,1200) pname(i), (pphi(j,i), j = 3, 8) 
         end do
      end if 

      if (iopt(1).eq.1.or.iopt(1).eq.2) then 
c                                      output with averaging
         do i = 1, nphi
            k = idphi(i)
            call blktxt (pname(i),k,1)
            write (n3,1030) pname(i),  
     *                      swt(i)/ptot(2,jd)*1e2,
     *                      sphi(11,i)*1e2,(scomps(i,l), l = 1, icomp)
         end do 

         write (n3,1160)
c                                     phase/system summary, normal thermo:
         do i = 1, nphi
c                                     N, H, V, Cp, alpha, beta
            write (n3,1170) pname(i), props(2,i,jd),sphi(2,i),sphi(1,i),
     *                  (sphi(j,i), j = 12, 14), sphi(10,i)
         end do

         write (n3,1170) 'System              ',ptot(2,jd),psys(2),
     *                psys(1),psys(12),psys(13),psys(14)

         if (iflu(jd).eq.1) 
     *   write (n3,1170) 'System - Fluid      ',ptot1(2,jd),psys1(2),
     *                   psys1(1),psys1(12),psys1(13),psys1(14)

         write (n3,1190)
c                                     phase/system summary, seismic:
         do i = 1, nphi
            write (n3,1200) pname(i), (sphi(j,i), j = 3, 8) 
         end do

      end if 


      if (iflu(jd).eq.0) then 
c                                     no fluid is present:
         write (n3,1210)

         write (n3,1040)

         do i = 1, icomp

            write (n3,1110) cname(i),fbulk(i,jd), 
     *                      fbulk(i,jd)/gtot(jd)*1e2,
     *                      fbulk(i,jd)*atwt(i)/btot(jd)*1e2                            
         end do

         write (n3,1220)

         write (n3,1060) psys(10), 
c                                     enthalpy, specific enthalpy
     *                   psys(2)/psys(1)*1d5/psys(10),
     *                   psys(2)/psys(1)*1d5, 
c                                     entropy, specific entropy 
     *                   psys(15)/psys(1)*1d5/psys(10),
     *                   psys(15)/psys(1)*1d5,
c                                     cp, specific cp 
     *                   psys(12)/psys(1)*1d5/psys(10),
     *                   psys(12)/psys(1)*1d5,(psys(j),j= 3, 8)

      else 
c                                     fluid is present
         write (n3,1210)

         write (n3,1080)

         do i = 1, icomp

            write (n3,1110) cname(i),fbulk(i,jd),
     *                  fbulk(i,jd)/gtot(jd)*1e2,
     *                  fbulk(i,jd)*atwt(i)/btot(jd)*1e2,
     *                  fbulk1(i,jd)/gtot1(jd)*1e2,
     *                  fbulk1(i,jd)*atwt(i)/btot1(jd)*1e2          
         end do

         write (n3,1220)
c                                     true bulk properties:
         write (n3,1060) psys(10), 
c                                     enthalpy, specific enthalpy
     *                   psys(2)/psys(1)*1d5/psys(10),
     *                   psys(2)/psys(1)*1d5, 
c                                     entropy, specific entropy 
     *                   psys(15)/psys(1)*1d5/psys(10),
     *                   psys(15)/psys(1)*1d5,
c                                     cp, specific cp 
     *                   psys(12)/psys(1)*1d5/psys(10),
     *                   psys(12)/psys(1)*1d5,(psys(j),j= 3, 8)
c                                      solid only bulk properties:
         write (n3,1100) psys1(10), 
c                                     enthalpy, specific enthalpy
     *                   psys1(2)/psys1(1)*1d5/psys1(10),
     *                   psys1(2)/psys1(1)*1d5, 
c                                     entropy, specific entropy 
     *                   psys1(15)/psys1(1)*1d5/psys1(10),
     *                   psys1(15)/psys1(1)*1d5,
c                                     cp, specific cp 
     *                   psys1(12)/psys1(1)*1d5/psys(10),
     *                   psys1(12)/psys1(1)*1d5,(psys1(j),j= 3, 8)

         write (n3,1230) 

      end if 

      write (n3,1070) 2, ivar(jd)

      if (idep.eq.0) then 
c                                      pressure and temperature are independent
         write (n3,1180) vname(jpt(1)),vr(jpt(1)-jcont,jd),
     *                   vname(jpt(2)),vr(jpt(2)-jcont,jd)

      else if (idep.eq.1) then 
c                                      pressure is dependent
         write (n3,1185) vname(jpt(2)),vr(jpt(2)-jcont,jd)
      else if (idep.eq.2) then 
c                                      temperature is dependent
         write (n3,1185) vname(jpt(1)),vr(jpt(1)-jcont,jd)
      end if 

1000  format (' ---------',/,1x,'(',i5,') Stable phases at:')
1020  format (/,46x,'Phase Compositions (',a,'):',
     *        /,26x,'wt %',4x,'vol % (2)',3x,20(a,3x))
1030  format (1x,a20,3x,2(f6.2,4x),20(f6.2,2x))
1040  format (/,14x,'mol',7x,'mol %',6x,'wt %')
1050  format (/,'WARNING - negative mass indicates the bulk'
     *         ,' composition is',/,'inconsistent with the'
     *         ,' saturation constraints',/)
1060  format (/,'Density (kg/m3) (2) = ',f7.1,/, 
     *          'Enthalpy (J/kg) (2) = ',g12.6,/,
     *          'Specific Enthalpy (J/m3) (2) = ',g12.6,/,
     *          'Entropy (J/K/kg) (2) = ',g12.6,/,
     *          'Specific Entropy (J/K/m3) (2) = ',g12.6,/,
     *          'Heat Capacity (J/K/kg) (1) = ',g12.6,/,
     *          'Specific Heat Capacity (J/K/m3) (1) = ',g12.6,/,
     *          'Aggregate Grueneisen Ratio (2,3) = ',g12.6,/,
     *          'Aggregate Adiabatic Bulk Modulus (bar) (2,3) = ',g12.6,
     *        /,'Aggregate Shear Modulus (bar) (2,3,4) = ',g12.6,/,
     *          'Aggregate Sound Velocity (km/s) (2,3) = ',g12.6,/,
     *          'Aggregate P-Wave Velocity (km/s) (2,3,4) = ',g12.6,/,
     *          'Aggregate S-Wave Velocity (km/s) (2,3,4) = ',g12.6,/)
1070  format (/,'Variance (c-p+',i1,') = ',i2)
1080  format (/,16x,'Complete Assemblage',15x,'Solid+Melt Only',
     *        /,14x,'mol',7x,' mol %',6x,'wt %',9x,' mol %',6x,'wt %',/)
1100  format (/,'Solid Density (kg/m3) (2) = ',f7.1,/, 
     *          'Solid Enthalpy (J/kg) (2) = ',g12.6,/,
     *          'Solid Secific Enthalpy (J/m3) (2) = ',g12.6,/,
     *          'Solid Entropy (J/K/kg) (2) = ',g12.6,/,
     *          'Solid Specific Entropy (J/K/m3) (2) = ',g12.6,/,
     *          'Solid Heat Capacity (J/K/kg) (1) = ',g12.6,/,
     *          'Solid Specific Heat Capacity (J/K/m3) (1) = ',g12.6,/,
     *          'Aggregate Solid Melt Grueneisen Ratio (2,3) = ',g12.6,/
     *         ,'Aggregate Solid Adiabatic Bulk Modulus (bar) (2,3) = ',
     *  g12.6,/,'Aggregate Solid Shear Modulus (bar) (2,3,4) = ',g12.6,/
     *         ,'Aggregate Solid Sound Velocity (km/s) (2,3) = ',g12.6,/
     *         ,'Aggregate Solid P-Wave Velocity (km/s) (2,3,4) = ',
     *  g12.6,/,'Aggregate Solid S-Wave Velocity (km/s) (2,3,4) = ',
     *                                                          g12.6,/)
1110  format (1x,a8,2x,f8.3,5x,2(f6.2,4x),5x,2(f6.2,4x))
1120  format (29x,a8,' = ',g12.6)
1130  format (20(i5,1x))
1140  format (12(f6.2,1x))
1150  format (12(g14.6,1x))
1160  format (/,25x,'Molar Properties (2):'
     *        /,27x,'N(g)',8x,'H(J)',5x,'V(J/bar)',6x,'Cp(J/K)'
     *         ,6x,'Alpha(1/K)',2x,'Beta(1/bar)',2x,'Density(kg/m3)')
1170  format (1x,a20,1x,f9.2,3x,12(g12.5,1x))
1180  format (/,'Notes:',/,
     *         '1 - Computed at reference condition (',a8,'=',f6.0,
     *         ', ',a8,'=',f5.0,').',/,
     *         '2 - Computed from linearized equation of state',
     *         ' relative to the reference condition.',/,
     *         '3 - Computed by Voigt-Reuss-Hill scheme (e.g., Bina ',
     *         '& Helfrich 1992).',/,
     *         '4 - If zero, shear modulus data is not in the data ',
     *         'base.',/,'---------',/)
1185  format (/,'Notes:',/,
     *         '1 - Computed at reference condition (',a8,'=',f6.0,
     *         ').',/,
     *         '2 - Computed from linearized equation of state',
     *         ' relative to the reference condition.',/,
     *         '3 - Computed by Voigt-Reuss-Hill scheme (e.g., Bina ',
     *         '& Helfrich 1992).',/,
     *         '4 - If zero, shear modulus data is not in the data ',
     *         'base.',/,'---------',/)
1190  format (/,25x,'Seismic (Molar) Properties(2):'
     *        /,24x,'Gruneisen',7x,'Ks(bar)',7x,'Mu(bar)',
     *        4x,'V0(km/s)',5x,'Vp(km/s)',5x,'Vs(km/s)')
1200  format (1x,a20,3x,12(g12.5,1x))
1210  format (/,'Bulk Composition:')
1220  format (/,'Bulk Properties:')
1230  format (/,'N.B.: Aggregate properties represent the entire stable'
     *         ,' assemblage.',/,'Solid aggregate properties represent '
     *         ,'solid and melt properties,',/,'but do not include '
     *         ,'molecular fluid properties.',/)

      end 

      subroutine xytopt (x,y,p,t,dp,dt,jd)
c------------------------------------------------------------------
c this is a routine to determine if the x-y variables of a section
c are pressure and temperature and to calculate the appropriate
c displacements dp and dt from the reference pressure temperature
c conditions for polygon properties. this is sloppy and could be 
c avoided by using the pointer system in vertex
c------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      parameter (l3=l2+2)
 
      common/ cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / vs /vmin(l3),vmax(l3),iv/ cst315 /jcont/ cst321 /interp
     *      / cst316 /c0,c1,c2,c3,c4,iind,idep

      dt = 0e0
      dp = 0e0
c                                           jpt points to pressure and temperature
c                                           in the arrays jv, vmin, etc...
c                                           but not to the p and t in the vr array
      p = vmin(jpt(1))
      t = vmin(jpt(2))

c    if (interp.eq.1) goto 99
c                                           first case, idep = 0
c                                           means there P and T are independent
c                                           variables
      if (idep.eq.0) then 

         if (jpt(1).eq.1) then
c                                           pressure is the first (x) variable,
c                                           then jcont must be zero
            dp = x - vr(jpt(1),jd)
            p = x
         else if (jpt(1).eq.2) then
c                                           pressure is the second (y) variable
c                                           in case the first variable is an x
c                                           (jcont=1) shift pointer for vr                                                
            dp = y - vr(jpt(1)-jcont,jd)
            p = y 
         end if

         if (jpt(2).eq.1) then
c                                           temperature is the first (x) variable,
c                                           then jcont must be zero
            dt = x - vr(jpt(2),jd)
            t = x
         else if (jpt(2).eq.2) then
c                                           temperature is the second (y) variable
c                                           in case the first variable is an x
c                                           (jcont=1) shift pointer for vr
            dt = y - vr(jpt(2)-jcont,jd)
            t = y 
         end if 
 
      else
c                                           in this case the user has defined p(t) 
c                                           (idep=1) or t(p) (idep=2).
         if (jcont.eq.1) then
c                                           then if jpt(1)
            if (idep.eq.1.and.jpt(2).eq.3) then
c                                           t is the y variable
               dt = y -  vr(1,jd)
               t = y 
               p = c0 + c1*t + c2*t**2 + c3*t**3 + c4*t**4
               tr = t - dt
               pr = c0 + c1*tr + c2*tr**2 + c3*tr**3 + c4*tr**4 
               dp = p - pr
            else if (idep.eq.2.and.jpt(1).eq.2) then
c                                           p is the y variable
               dp = y -  vr(1,jd)
               p = y 
               t = c0 + c1*p + c2*p**2 + c3*p**3 + c4*p**4  
               pr = p - dp
               tr = c0 + c1*pr + c2*pr**2 + c3*pr**3 + c4*pr**4 
               dt = t - tr
            end if 

         else if (jcont.eq.0) then 
c                                           now the user has a 1d calculation (check fractionation)
c                                           or is using mu or xco2 as a section variable
            if (jpt(1).eq.1) then 
c                                           pressure is x
               dp = x - vr(1,jd)
               p = x
               t = c0 + c1*p + c2*p**2 + c3*p**3 + c4*p**4  
               dt = t - vr(2,jd)
            else if (jpt(1).eq.2) then 
c                                           pressure is y
               dp = y -  vr(1,jd)
               p = y
               t = c0 + c1*p + c2*p**2 + c3*p**3 + c4*p**4  
               dt = t - vr(2,jd)
            else if (jpt(2).eq.1) then 
c                                           temperature is x
               dt = x -  vr(1,jd)
               t = x
               p = c0 + c1*t + c2*t**2 + c3*t**3 + c4*t**4  
               dp = p - vr(1,jd)
            else if (jpt(2).eq.2) then 
c                                           temperature is y
               dt = y -  vr(1,jd)
               t = y
               p = c0 + c1*t + c2*t**2 + c3*t**3 + c4*t**4
               dp = p - vr(1,jd)
            end if                                                          
         end if 

      end if 
c                                           if interpolation is
c                                           shut off, set increments to
c                                           zero    
99    if (interp.eq.1) then 
         dp = 0e0
         dt = 0e0
      end if 

      end 


      subroutine blktxt (pname,id,imod)
c-----------------------------------------------------------------------
c subprogram to write a text labels for bulk composition output 
c  id   - phase id
c  imod - 0 -> return solution name + pcompound name
c         1 -> return only solution name
c-----------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      character*8 names, text(20)*1, fname*10, pname*20

      integer imod

      common/ cst8  /names(k1)/ csta7 /fname(h9)/ phase /ikp(k1)    
c                             dump the names into the array text
         if (ikp(id).eq.0) then
c                             simple compound:
            iend = 8
            read (names(id),1000) (text(j), j = 1, iend)
            call ftext1 (text,iend)
            write (pname,1000) (text(j), j = 1, iend)
         else  
c                             solution phases:
            iend = 10
            read (fname(ikp(id)),1000) (text(j), j = 1, 10)
            if (imod.eq.0) then 
               iend = 20
               text(11) = '('
               read (names(id),1000) (text(j), j = 12, 19)
               text(20) = ')'
               call ftext1 (text,iend)
            end if 
            write (pname,1000) (text(j), j = 1, iend)
         end if 

1000  format (20a1)

      end 

      subroutine ftext1 (text,iend)
c-----------------------------------------------------------------------
c subprogram to filter blanks from text 
c-----------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      character*1 text(20)

      itic = 0 

      do i = 1, iend

         if (text(i).ne.' ') then 
            itic = itic + 1
            text(itic) = text(i)
         end if 

      end do 

      iend = itic 
 
      end

      subroutine rerror (ier,*)
c---------------------------------------------------------------------
c rerror - routine to check for errors during list directed i/o
 
      implicit real (a-g,o-z),integer (h-n)
c---------------------------------------------------------------------
 
      if (ier.eq.0) then
         return
      else
         write (*,1000)
         ier = 0
         return 1
      end if
 
1000  format (/,'Your input is incorrect, probably you are using ',
     *        'a character where',/,'you should be using a number ',
     *        'or vice versa, try again...',/)
 
      end

c---------------------------------------------------------------
      subroutine rnam1 (iex,jex)

      implicit real (a-g,o-z),integer (h-n)

      character*10 xnam

      iex = 0
      jex = 0

110   write (*,1040) 
      read (*,1020) xnam

      call matchi (xnam,iex,jex)

      if (iex.eq.-1) then
         write (*,1100) xnam
         goto 110
      end if

      if (iex.eq.0) iex = -1

1020  format (a)
1040  format (/,'Enter solution or compound name (left justified): ')
1100  format (/,'No such entity as ',a,', try again: ')

      end

      subroutine matchi (unnown,itis,icpd)
c----------------------------------------------------------------
 
c matchi - subroutine to determine if the string unnown is a valid
c          solution or compound name.
 
c   itis = 0 if compound, = ikp if solution, and =-1 if invalid
c   icpd = the id of the compound if itis = 0

      implicit real (a-g,o-z),integer (h-n)
 
      character*10 sname, names*8, unnown
 
      include 'perplex_parameters.h'
 
      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common/ cst8 /names(k1)/ csta7 /sname(h9)/ phase /ikp(k1)
 
      if (isoct.ne.0) then
         do i = 1, isoct
            if (unnown.eq.sname(i)) then
               itis = i
               goto 99
             end if
         end do
      end if
 
      do i = 1, iphct
         if (unnown.eq.names(i)) then
            itis = 0
            icpd = i
            goto 99
         end if
      end do 
 
      itis = -1
99    end

      subroutine chsprp (lop,icx,jcx,jcx1,icps,rcps)
c----------------------------------------------------------------
c chsprp asks the user to choose a property for contouring:
c   lop  - flag indicating the property chosen
c   icx  - if lop = 6, the component chosen
c   icx  - if lop > 6, the identity of the solution chosen,
c          icx = -1 if a solution is not chosen.
c   jcx  - if lop = 7, the identity of the compound chosen,
c          if a solution is not chosen.
c   jcx  - if lop = 8, the number of components to define the
c          the phase composition.
c   icps - if lop = 8, the indices of the components. 
c   jflu - 0 include fluids for bulk props, else 1.

c 1                 Specific enthalpy (J/m3)',
c 2                 Density (kg/m3)',
c 3                'Specific Heat capacity (J/K/m3)',
c 4                'Expansivity (1/K, for volume)',
c 5                'Compressibility (1/bar, for volume)',
c 6                'Weight percent of a component',
c 7                'Mode (Vol %) of a compound or solution',
c 8                'Composition of a solution'
c 9                 Grueneisen thermal ratio',
c 10               'Adiabatic bulk modulus (bar)',
c 11               'Shear modulus (bar)'
c 12                Sound velocity (km/s)
c 13               'P-wave velocity (km/s)',
c 14                S-wave velocity (km/s)',
c 15                Vp/Vs
c 16               'Specific Entropy (J/K/m3)'
c 17               'Entropy (J/K/kg)'
c 18               'Enthalpy (J/kg)'
c 19               'Heat Capacity (J/K/kg)'
c 20               'Mass (kg) of a phase'
c 21               'Specific mass (kg/m3) of a phase'
c----------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      parameter (l3=l2+2,kprop=20)

      character*5 cname
 
      common/ csta4 /cname(k5)/ cst20 /comps(k1,k5),atwt(k5),icomp
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst320 /jflu/ opts /iopt(10)

      real rcps(k7)

      integer icps(k7)

      character propty(kprop)*60, y*1, units*15

      save propty

      data propty/'Specific Enthalpy (J/m3)',
     *            'Density (kg/m3)',
     *            'Specific heat capacity (J/K/m3)',
     *            'Expansivity (1/K, for volume)',
     *            'Compressibility (1/bar, for volume)',
     *            'Weight (%) of a component',
     *            'Mode (Vol, Mol, or Wt proportion) of a phase',
     *            'Composition (Mol or Wt) of a solution',
     *            'Grueneisen thermal ratio',
     *            'Adiabatic bulk modulus',
     *            'Shear modulus (bar)',
     *            'Sound velocity (km/s)',
     *            'P-wave velocity (Vp, km/s)',
     *            'S-wave velocity (Vs, km/s)',
     *            'Vp/Vs',
     *            'Specific Entropy (J/K/m3)',
     *            'Entropy (J/K/kg)',
     *            'Enthalpy (J/kg)',
     *            'Heat Capacity (J/K/kg)',
     *            'Specific mass of a phase (kg/m3-solid)'/
c-------------------------------------------
      jflu = 0
c                                choose property
5000  write (*,1050)

      do i = 1, kprop
         write (*,1060) i,propty(i)
      end do 

      read (*,*,iostat=ier) lop
      call rerror (ier,*5000)

      if (lop.eq.7.or.lop.eq.20) then 
c                                modes:
c                                get the phase name
          call rnam1 (icx,jcx)
c                                ask if fluid should be included:
          if (ivol.ne.0) then 
             write (*,1120) 
             read (*,'(a)') y
             if (y.eq.'y'.or.y.eq.'Y') jflu = 1 
          end if 

      else if (lop.ne.6.and.lop.ne.8) then 
c                                if lop .ne. 6 or 8 ask if
c                                bulk property or a phase property
         write (*,1110) 
         read (*,'(a)') y
         if (y.ne.'y'.and.y.ne.'Y') then 
            icx = -1 
            jcx = -1 
c                                it's a bulk property, ask if fluid
c                                should be included:
            if (ivol.ne.0) then 
               write (*,1120) 
               read (*,'(a)') y
               if (y.eq.'y'.or.y.eq.'Y') jflu = 1 
            end if 

         else 
c                                get the phase name
            call rnam1 (icx,jcx)
            if (icx.lt.1.and.lop.eq.8) write (*,*) 
     *         'hey cowboy, that warnt no solution, try again'
         end if
 
      else if (lop.eq.6) then
c                                get the component to be contoured
5010     write (*,1000)
         write (*,1010) (i,cname(i),i = 1, icomp)
         read (*,*,iostat=ier) icx
         call rerror (ier,*5010)   
c                                ask if fluids included
         if (ivol.ne.0) then 
            write (*,1120) 
            read (*,'(a)') y
            if (y.eq.'y'.or.y.eq.'Y') jflu = 1 
         end if 

      else if (lop.eq.8) then
c                                get the solution identity
5005     call rnam1 (icx,jcx)
         if (icx.lt.1) then 
            write (*,*) 'hey cowboy, that warnt no solution, try again'
            goto 5005
         end if 
c                                choose units for composition
         if (iopt(2).eq.0) then
            units = 'mole proportion'
         else 
            units = 'weight fraction'
         end if 
c                                get the composition to be contoured
         write (*,1100) units

5050     write (*,1030) 'numerator'
         read (*,*,iostat=ier) jcx
         call rerror (ier,*5050) 
c                                define the numerator
5020     write (*,1040) 'numerator'
         write (*,1010) (i,cname(i),i = 1, icomp)
         read (*,*,iostat=ier) (icps(i),rcps(i), i = 1, jcx)
         call rerror (ier,*5020) 
c                                define the denominator
5030     write (*,1030) 'denominator'
         write (*,1140)
         read (*,*,iostat=ier) jcx1
         call rerror (ier,*5030) 
         jcx1 = jcx + jcx1

         if (jcx1.gt.jcx) then 
5040        write (*,1040) 'denominator'
            write (*,1010) (i,cname(i),i = 1, icomp)
            read (*,*,iostat=ier) (icps(i),rcps(i), i = jcx+1, jcx1)
            call rerror (ier,*5040)
c                                show the user the composition: 
            write (*,1080)           
            write (*,1130) (rcps(i),cname(icps(i)), i = 1, jcx)
            write (*,*) '   divided by '
            write (*,1130) (rcps(i),cname(icps(i)), i = jcx+1, jcx1)
         else 
            write (*,1070) (rcps(i),cname(icps(i)), i = 1, jcx)
         end if 
 
         write (*,1090)
         read (*,'(a)') y
         if (y.ne.'y') goto 5020
      end if 

1000  format (/,'Enter a component:')
1010  format (2x,i2,' - ',a5)
1020  format (/,'Component index and weighting factor for the',
     *        /,'compositions numerator?')
1030  format (/,'How many components in the ',a,' of the',
     *          ' composition?')
1040  format (/,'Component indices and weighting factors for the', 
     *        /,'compositions ',a,'?')
1050  format (/,'Select a property:')
1060  format (3x,i2,' - ',a60)
1070  format (/,'The compositional variable is: ',f4.1,1x,a5)
1080  format (/,'The compositional variable is: ',/)
1090  format (/,'Happy (y/n?)')
1100  format (/,'Compositions are defined as a ratio of the form:',/,
     *        4x,' Sum {w(i)*n(i), i = 1, c1} / Sum {w(i)*n(i), i',
     *        ' = c2, c3}',/,15x,
     *        ' n(j) = ',a,' of component j',/,15x,
     *        ' w(j) = weighting factor of component j (usually 1)',/)
1110  format (/,'Calculate individual phase properties (y/n)?')
1120  format (/,'Include fluid in computation of aggregate ', 
     *          '(or modal) properties (y/n)?')
1130  format (' Sum ',20(f4.1,1x,a5,1x))
1140  format ('Enter zero to plot the numerator.')

99    end

      subroutine polprp (prop,x,y)

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      real rcps, prop, x, y

      integer icps, icx, jcx, jcx1, lop, iam

      common / cst84 /rcps(k7),icps(k7),icx,jcx,jcx1,lop

c                             amiin gets iam, the pointer to the assemblage
c                             in the "b" file as a function of x-y coordinate
      call amiin (x,y,iam)  

      if (iam.eq.0) then 
         prop = -1e0
         write (*,1000) x, y
      else 
         call getprp (x,y,lop,iam,prop,icx,jcx,jcx1,icps,rcps)
      end if 

1000  format ('Missing data at: ',2(g12.6,1x),' assigned value -1')
      end 

      subroutine getprp (x,y,lop,jd,prop,icx,jcx,jcx1,icps,rcps)
c----------------------------------------------------------------
c getprp gets properties:

c   jd   - is the pointer to the assemblage
c   jflu - if 1, bulk properties include fluid phase; else 0

c   lop  - flag indicating the property chosen
c   icx  - if lop = 6, the component chosen
c   icx  - if lop > 6, the identity of the solution chosen,
c          icx = -1 if a solution is not chosen.
c   jcx  - if lop = 7, the identity of the compound chosen,
c          if a solution is not chosen.
c   jcx  - if lop = 8, the number of components to define the
c          numerator of the phase composition.
c   jcx  - if lop > 8 the identity of the compound if icx < 0,
c          if jcx and icx < 0, then bulk properties are to be 
c          computed.
c   jcx1 - if lop = 8, the number of components + jcx that define the
c          denominator of the phase composition.
c   icps - if lop = 8, the indices of the components. 
c   
c requestable properties (indicated by lop)

c 1                 Specific enthalpy (J/m3)',
c 2                 Density (kg/m3)',
c 3                 Specific Heat capacity (J/K/m3)',
c 4                 Expansivity (1/K, for volume)',
c 5                 Compressibility (1/bar, for volume)
c 6                 Weight percent of a component
c 7                 Mode (Vol %) of a compound or solution',
c 8                 Composition of a solution'
c 9                 Adiabatic bulk modulus (bar)',
c 10                Grueneisen thermal ratio',
c 11                Sound velocity (km/s)
c 12                Shear modulus (bar)',
c 13                P-wave velocity (km/s)',
c 14                S-wave velocity (km/s)',
c 15                Vp/Vs
c 16                Specific Entropy (J/K/m3)'
c 17                Entropy (J/K/kg)'
c 18                Enthalpy (J/kg)'
c 19                Heat Capacity (J/K/kg)'

c system properties from seismo:

c 1 vsys       - sys molar volume 
c 2 esys       - sys molar enthalpy 
c 3 grun       - sys gruenesien ratio
c 4 bulkm      - sys adiabatic bulk modulus
c 5 mu         - sys shear modulus
c 6 vel0       - sys sound velocity 
c 7 velp       - sys p-wave velocity
c 8 vels       - sys s-wave velocity
c 9 vp/vs      
c 10 rsys      - sys density
c 11 csys      - sys specific heat capacity
c 12 cp
c 13 alpha
c 14 beta 
c 15 entropy
c----------------------------------------------------------------

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      parameter (l3=l2+2)

      real rcps(k7)

      integer icps(k7)

      common/ cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)/ cst320 /jflu
     *      / cst81 /ptot(i8,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(i8,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst20 /comps(k1,k5),atwt(k5),icomp/ phase /ikp(k1)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst317 /pphi(i7,k5),psys(i7),psys1(i7),sphi(i7,k5),
     *                idphi(k5),nphi 

      if (lop.eq.8) then 
c                                  a solution composition
         call scomp (jd,prop,icx,jcx,jcx1,icps,rcps)

      else if (lop.eq.6) then 
c                                  wt % of component 
         if (iflu(jd).eq.0.or.(iflu(jd).eq.1.and.jflu.eq.1)) then 
c                                  include fluid
            prop = fbulk(icx,jd)*atwt(icx)/btot(jd)*1e2
         else 
c                                  exclude fluid
            prop = fbulk1(icx,jd)*atwt(icx)/btot1(jd)*1e2
         end if 
      
      else 
c                                  get p-t for thermo props:
         call xytopt (x,y,p,t,dp,dt,jd)
c                                  calculate phase and bulk props
         call seismo (p,t,dp,dt,jd)
c                                  according to props:
         if (lop.eq.7.or.lop.eq.20) then 
c                                  modes are a special case, vmodes
c                                  returns the renormalized mode if that has 
c                                  been requested. 
            call vmodes (prop,p,t,lop,icx,jcx,jd)

         else if (icx.lt.0.and.jcx.lt.0) then 
c                                  a system property is  requested:
            if (iflu(jd).eq.0.or.(iflu(jd).eq.1.and.jflu.eq.1)) then 
c                                  if jflu = 0 the property is to include 
c                                  fluid (if present), i.e, use psys/ptot array:
               if (lop.eq.1) then 
c 1                                  Specific enthalpy (J/m3)
c                                    psys(2)  is J/mole
c                                    psys(1)  is J/bar/mole (volume)
                  prop = psys(2)/psys(1)*1d5
               else if (lop.eq.2) then 
c 2                                  Density (kg/m3)
                  prop = psys(10)
               else if (lop.eq.3) then 
c 3                                  Specific Heat capacity (J/K/m3)
                 prop = psys(12)/psys(1)*1d5
               else if (lop.eq.4) then
c 4                                  Expansivity (1/K, for volume)
                  prop =  psys(13)
               else if (lop.eq.5) then 
c 5                                  Compressibility (1/bar, for volume)
                  prop =  psys(14)
               else if (lop.eq.9) then 
c                                    adiabatic bulk modulus
                  prop  = psys(4)       
               else if (lop.eq.10) then 
c                                    gruneisen T
                  prop = psys(3)
               else if (lop.eq.11) then 
c                                    shear modulus
                  prop = psys(5)
               else if (lop.eq.12) then 
c                                    sound velocity
                  prop = psys(6)
               else if (lop.ge.13.and.lop.le.15) then 
c                                    vp, vs, vp/vs
                  prop = psys(lop-6)
               else if (lop.eq.16) then 
c                                    specific s (j/k/m3)
                  prop = psys(15)/psys(1)*1d5
               else if (lop.eq.17) then 
c                                    S (J/K/kg)
                  prop = psys(15)/psys(1)*1d5/psys(10)
               else if (lop.eq.18) then 
c                                    H (J/kg)
                  prop = psys(2)/psys(1)*1d5/psys(10)
               else if (lop.eq.19) then
c                                    Cp (J/K/kg)
                  prop = psys(12)/psys(1)*1d5/psys(10)
               end if 
            else 
c                               fluid absent system properties:
               if (lop.eq.1) then 
c 1                                  Specific enthalpy (J/m3)
                  prop = psys1(2)/psys1(1)*1d5
               else if (lop.eq.2) then 
c 2                                  Density (kg/m3)
                  prop = psys1(10)
               else if (lop.eq.3) then 
c 3                                  Specific Heat capacity (J/K/m3)
                  prop = psys1(12)/psys1(1)*1d5
               else if (lop.eq.4) then
c 4                                  Expansivity (1/K, for volume)
                  prop =  psys1(13)
               else if (lop.eq.5) then 
c 5                                  Compressibility (1/bar, for volume)
                  prop =  psys1(14)
               else if (lop.eq.9) then 
c                                    adiabatic bulk modulus
                  prop  = psys1(4)       
               else if (lop.eq.10) then 
c                                    gruneisen T
                  prop = psys1(3)
               else if (lop.eq.11) then 
c                                    shear modulus
                  prop = psys1(5)
               else if (lop.eq.12) then 
c                                    sound velocity
                  prop = psys1(6)
               else if (lop.ge.13.and.lop.le.15) then 
c                                    vp, vs, vp/vs
                  prop = psys1(lop-6)
               else if (lop.eq.16) then
c                                    specific s (j/k/m3)
                  prop = psys1(15)/psys1(1)*1d5
               else if (lop.eq.17) then
c                                    S (J/K/kg)
                  prop = psys1(15)/psys1(1)*1d5/psys1(10)
               else if (lop.eq.18) then 
c                                    H (J/kg)
                  prop = psys1(2)/psys1(1)*1d5/psys1(10)
               else if (lop.eq.19) then
c                                    Cp (J/K/kg)
                  prop = psys1(12)/psys1(1)*1d5/psys1(10)
               end if 
            end if 
         else 
c                               we want a phase property:
             call vmodes (prop,p,t,lop,icx,jcx,jd)

         end if 

      end if                
 
99    end 

      subroutine scomp (jd,comp,icx,jcx,jcx1,icps,rcps)
c-------------------------------------------------------------------
c function scomp returns composition of a solution phase in 
c assemblage jd. if the phase is a solution icx is its index (>0),
c otherwise jcx is its index. the index is determined by rnam1.
c ------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      parameter (l3=l2+2)

      real rcps(k7), cps(k5) 

      integer icps(k7)
 
      common/ cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)
     *      / phase /ikp(k1)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst20 /comps(k1,k5),atwt(k5),icomp/ opts /iopt(10)

      comp = 0e0 
      totden = 0e0 
      tmol = 0e0

      do j = 1, jbulk
         cps(j) = 0d0
      end do 

      do i = 1, jbulk

         if (ikp(idbk(i,jd)).eq.icx) then 
c                                          first get the solution 
c                                          molar composition
            do j = 1, jbulk
               cps(j) = cps(j) + props(1,i,jd)*comps(idbk(i,jd),j)
            end do 

            tmol = tmol + props(1,i,jd)
         end if 
      end do 
c                                           if tmol = 0 not found
      if (tmol.eq.0d0) goto 99

      if (iopt(2).eq.0) then 
c                                           normalize composition to 
c                                           molar stoichiometry
         do i = 1, jbulk
            cps(i) = cps(i)/tmol
         end do 

      else 
c                                           normalize to weight fractions
         tmass = 0d0 

         do i = 1, jbulk 
            cps(i) = cps(i) * atwt(i)
            tmass = tmass + cps(i)
         end do 

         do i = 1, jbulk 
            cps(i) = cps(i)/tmass*1d2
         end do 
      end if 
c                                           now compute the composition:
c                                           numerator:
      do j = 1, jcx 
         comp = comp + rcps(j)*cps(icps(j))
      end do
c                                           denominator:
      do j = jcx+1, jcx1 
         totden = totden + rcps(j)*cps(icps(j))
      end do     
c                                           numerator/denominator:        
      if (totden.ne.0e0) comp = comp / totden

99    end

      function wtp (jcomp,jd)
c-------------------------------------------------------------------
c function wtp returns weight fraction of component jcomp in 
c assemblage jd.
c ------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'
 
      common/ cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)
     *      / cst81 /ptot(i8,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(i8,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst20 /comps(k1,k5),atwt(k5),icomp

      if (iflu(jd).eq.0) then 
        
            wtp = fbulk(jcomp,jd)*atwt(jcomp)/btot(jd)*1e2                           
  
      else 
c                                   if fluid is present use 
c                                   solid-only totals:
            wtp = fbulk1(jcomp,jd)*atwt(jcomp)/btot(jd)*1e2  

      end if 

      end

      subroutine vmodes (prop,p,t,iprop,icx,jcx,jd) 
c-------------------------------------------------------------------
c function vmode returns a property of a phase in 
c assemblage jd. if the phase is a solution icx is its index (>0),
c otherwise jcx is its index. the index is determined by rnam1.

c the property is identified by the index iprop:

c 1                 enthalpy (J/m3)
c 2                 density (kg/m3)
c 3                 Heat capacity (J/K/m3)
c 4                 Expansivity (1/K, for volume)
c 5                 Compressibility (1/bar, for volume)
c 7                 Mode (Vol %) of a compound or solution
c 9                 Adiabatic bulk modulus (bar)
c 10                Grueneisen thermal ratio
c 11                Sound velocity (km/s)
c 12                Shear modulus (bar)
c 13                P-wave velocity (km/s)
c 14                S-wave velocity (km/s)
c 15                Vp/Vs
c 16                Specific Entropy (J/K/m3)'
c 17                Entropy (J/K/kg)'
c 18                Enthalpy (J/kg)'
c 19                Heat Capacity (J/K/kg)'
c------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      parameter (l3=l2+2)
 
      common/ cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)
     *      / cst81 /ptot(i8,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(i8,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst20 /comps(k1,k5),atwt(k5),icomp/ phase /ikp(k1)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst317 /pphi(i7,k5),psys(i7),psys1(i7),sphi(i7,k5),
     *                idphi(k5),nphi
     *      / cst320 /jflu/ cst322 /cwt(k5),swt(k5),twt(k5)
     *      / opts /iopt(10)

      prop = 0d0

      if (icx.gt.0) then 
c                                           we are looking for a solution
c                                           prop saved in sphi:
         do j = 1, nphi
            if (ikp(idphi(j)).eq.icx) then 
               if (iprop.eq.1) then
c                                           specific enthalpy 
                  prop = sphi(2,j)/sphi(1,j)*1e5
               else if (iprop.eq.2) then 
c                                           density (kg/m3)
                  prop = sphi(10,j)
               else if (iprop.eq.3) then 
c                                           specific cp 
                  prop = sphi(12,j)/sphi(1,j)*1e5
               else if (iprop.eq.4) then 
c                                           expansivity
                  prop = sphi(13,j)
               else if (iprop.eq.5) then 
c                                           compressibility
                  prop = sphi(14,j)
               else if (iprop.eq.7) then                           
c                                           mode (%)
                  if (jflu.eq.1.or.iflu(jd).eq.0) then
c                                           total mode:
                     if (iopt(3).eq.0) then 
c                                           volume fraction
                        prop = sphi(11,j)*1e2
                     else  
c                                           weight fraction
                        prop = swt(j)/ptot(1,jd)*1e2
                     end if 
                  else 
c                                           solid only mode:
                     if (iopt(3).eq.0) then 
c                                           volume fraction
                        prop = sphi(11,j)*1e2*psys(1)/psys1(1)
                     else 
c                                           wt fraction
                        prop = swt(j)/ptot1(1,jd)*1e2
                     end if 
                  end if 
               else if (iprop.eq.9) then 
c                                    adiabatic bulk modulus
                  prop = sphi(4,j)       
               else if (iprop.eq.10) then 
c                                    gruneisen T
                  prop = sphi(3,j)
               else if (iprop.eq.11) then 
c                                    sound velocity
                  prop = sphi(6,j)
               else if (iprop.eq.12) then 
c                                    shear modulus
                  prop = sphi(5,j)
               else if (iprop.ge.13.and.iprop.le.15) then 
c                                           seismic props
                  prop = sphi(iprop-6,j)  
               else if (iprop.eq.16) then
c                                    specific s (j/k/m3)
                  prop = sphi(15,j)/sphi(1,j)*1d5
               else if (iprop.eq.17) then 
c                                    S (J/K/kg)
                  prop = sphi(15,j)/sphi(1,j)*1d5/sphi(10,j)
               else if (iprop.eq.18) then 
c                                    H (J/kg)
                  prop = sphi(2,j)/sphi(1,j)*1d5/sphi(10,j)
               else if (iprop.eq.19) then
c                                    Cp (J/K/kg)
                  prop = sphi(12,j)/sphi(1,j)*1d5/sphi(10,j)
               else if (iprop.eq.20) then                           
c                                           specific weight of a
c                                           phase is the mass per
c                                           m3 of solid+melt

c                                           the number of moles of
c                                           system/m3 is 1e5/psys(1)
c                                           twt is g/mol phase                                        
                  if (iflu(jd).eq.0) then
c                                           total mode:
                     prop = swt(j)*1e2/psys(1)
                  else 
c                                           solid only mode:
                     prop = swt(j)*1e2/psys1(1)
                  end if 

               end if 
               goto 99 
            end if 
         end do 

      else
c                                           we are looking for a cpd in pphi
         do j = 1, jbulk
            id = idbk(j,jd)
            if (id.eq.jcx) then 
               if (iprop.eq.1) then
c                                           specific enthalpy
                  prop = pphi(2,j)/pphi(1,j)*1e5
               else if (iprop.eq.2) then 
c                                           density
                  prop = pphi(10,j)
               else if (iprop.eq.3) then 
c                                           specific cp 
                  prop = pphi(12,j)/pphi(1,j)*1e5
               else if (iprop.eq.4) then 
c                                           expansivity
                  prop = pphi(13,j)
               else if (iprop.eq.5) then 
c                                           compressibility
                  prop = pphi(14,j)
               else if (iprop.eq.7) then                           
c                                           mode (%)
                  if (jflu.eq.0.or.iflu(jd).eq.0) then
c                                           total mode:
                     prop = pphi(11,j)*1e2
                  else 
c                                           solid only mode:
                     prop = pphi(11,j)*1e2*psys(1)/psys1(1)
                  end if 
               else if (iprop.eq.9) then 
c                                    adiabatic bulk modulus
                  prop = pphi(4,j)       
               else if (iprop.eq.10) then 
c                                    gruneisen T
                  prop = pphi(3,j)
               else if (iprop.eq.11) then 
c                                    sound velocity
                  prop = pphi(6,j)
               else if (iprop.eq.12) then 
c                                    shear modulus
                  prop = pphi(5,j)
               else if (iprop.ge.13.and.iprop.le.15) then 
c                                           seismic props
                  prop = pphi(iprop-6,j)  
               else if (iprop.eq.16) then
c                                    specific s (j/k/m3)
                  prop = pphi(15,j)/pphi(1,j)*1d5
               else if (iprop.eq.17) then 
c                                    S (J/K/kg)
                  prop = pphi(15,j)/pphi(1,j)*1d5/pphi(10,j)
               else if (iprop.eq.18) then 
c                                    H (J/kg)
                  prop = pphi(2,j)/pphi(1,j)*1d5/pphi(10,j)
               else if (iprop.eq.19) then
c                                    Cp (J/K/kg)
                  prop = pphi(12,j)/pphi(1,j)*1d5/pphi(10,j)
               else if (iprop.eq.20) then 
c                                           specific weight of a
c                                           phase is the mass per
c                                           m3 of solid+melt

c                                           the number of moles of
c                                           system/m3 is 1e5/psys(1)
c                                           twt is g/mol phase                                        
                  if (iflu(jd).eq.0) then
c                                           total mode:
                     prop = cwt(j)*1e2/psys(1)
                  else 
c                                           solid only mode:
                     prop = cwt(j)*1e2/psys1(1)
                  end if                          
               end if 
               goto 99 
            end if 
         end do 

      end if     

99    end

      subroutine inblnk (text,char)
c------------------------------------------------------------------- 
c inblnk - scan text to last '/' or '\' and insert char after.
 
c     text - character string 
c-------------------------------------------------------------------
 
      character text*(*), bitsy(400)*1, char*1 
 
      read (text,1000) bitsy
c                                 scan for blanks:
      ict = 0
      nchar = len(text)

      do i = nchar,1,-1
         if (bitsy(i).eq.'/') goto 10
         bitsy(i+1) = bitsy(i)
      end do 

      i = 0

10    bitsy(i+1) = char

      write (text,1000) (bitsy(i), i = 1, nchar)
 
1000  format (400a1)

      end

      subroutine seismo (p,t,dp,dt,jd)  
c-------------------------------------------------------------------
c input:

c   p, t, dp, dt - conditions set by prior call to  xytopt 

c output:

c 1 - vphi(k5)   - cpd volume 
c 2 - ephi(k5)   - cpd enthalpy 
c 3 - grunp(k5)  - cpd gruenesien ratio
c 4 - bulkmp(k5) - cpd adiabatic bulk modulus
c 5 - mup(k5)    - cpd shear modulus
c 6 - vel0p(k5)  - cpd sound velocity 
c 7 - velsp(k5)  - cpd s-wave velocity
c 8 - velpp(k5)  - cpd p-wave velocity
c 9 - vp/vs
c10 - rhop(k5)   - cpd density
c11 - vfract(k5) - cpd volume fraction
c12 - cp
c13 - alpha
c14 - beta 
c15 - entropy

c 1 vsys       - sys molar volume (j/bar/mol)
c 2 esys       - sys molar enthalpy (j/mol)
c 3 grun       - sys gruenesien ratio
c 4 bulkm      - sys adiabatic bulk modulus
c 5 mu         - sys shear modulus
c 6 vel0       - sys sound velocity 
c 7 velp       - sys p-wave velocity
c 8 vels       - sys s-wave velocity
c 9 vp/vs      
c 10 rsys      - sys density
c 11 csys      - sys specific heat capacity
c 12 cp
c 13 alpha
c 14 beta 
c 15 entropy

c wt  - array of pseudocompound masses per mole of system
c twt - array of phase masses per model of system
c-------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h' 

      parameter (l3=l2+2)

      real pgeo(i7), pgeo1(i7), alpha, chi, chi1

      integer ikrank

      common/ cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst81 /ptot(i8,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(i8,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst317 /pphi(i7,k5),psys(i7),psys1(i7),sphi(i7,k5),
     *                idphi(k5),nphi
     *      / cst319 /iemod(k2),kmod/ phase /ikp(k1)
     *      / cst322 /cwt(k5),swt(k5),twt(k5)/ opts /iopt(10)
     *      / cst20  /comps(k1,k5),atwt(k5),icomp
     *      / cst324 /scomps(k5,k5),pcomp(k5,k5)
c                                      weighting factors for voigt and reuss
c                                      averages (harmonic/arithmetic) 
      save chi, itic
c                                      weighting scheme for seismic velocity
c                                      chi = 1 -> voigt
c                                            0 -> reuss
      data chi, itic/1d0, 0/
c
      chi1 = 1d0 - chi
c                                      determine if x and/or y are 
c                                      pressure or temperature:
      do j = 1, i7
         psys(j) = 0d0
         pgeo(j) = 0d0
         psys1(j) = 0d0
         pgeo1(j) = 0d0
         do i = 1, jbulk
            sphi(j,i) = 0d0
         end do 
      end do
c                                       initial true phase counter and props
      nphi = 0
      jtic = 0
      ktic = 0 
      iold = -1
      ikrank = 0 
      iwarn = 0 
c                                    first loop gets basic props
c                                    and simple means:
      do i = 1, jbulk

         idphi(i) = 0
c                                    cpd id:
         id = idbk(i,jd)
c                                    bad assemblage, bad exit
         if (id.eq.0) goto 99
c                                    save phase compositions in units 
c                                    of choice (from iopt(2))
         if (iopt(2).eq.0) then 
c                                    we want molar phase compositions
            do k = 1, jbulk
               pcomp(i,k) = comps(id,k)
            end do 

         else 
c                                    weight compositions:
            do k = 1, jbulk
               pcomp(i,k) = comps(id,k)*atwt(k)/props(2,i,jd)*1e2
            end do    
         end if 
c                                    wt for molar wieghted system props
         wt        = props(1,i,jd)
         if (wt.lt.0d0) wt = 0d0
c                                    mass of phase per mole of system
         cwt(i)    = wt * props(2,i,jd)
c                                    cpd molar volume
         pphi(1,i) = props(4,i,jd) 
c                                    + dv/dp at Tr
     *               +(props(7,i,jd) + props(10,i,jd)*dp/2d0)*dp
c                                    + dv/dt at Pr
c                                    including high order 
c                                    terms seems to be asking for 
c                                    trouble.
     *               +(props(6,i,jd) + props( 9,i,jd)*dp
     *                               + props( 8,i,jd)*dt/2d0)*dt
c    *                               + props(11,i,jd)*dt*dt/6d0)*dt
c                                    cpd heat capacity
         pphi(12,i) = props(5,i,jd) 
c                                    cpd expansivity
         pphi(13,i) = (props(6,i,jd) + props( 9,i,jd)*dp
     *               + props( 8,i,jd)*dt)/pphi(1,i)
c    *               +(props( 8,i,jd)+ props(11,i,jd)/2d0*dt)*dt)/pphi(1,i)
c                                    cpd compressibility
         pphi(14,i) = -(props(7,i,jd) + props( 9,i,jd)*dt
     *                                + props(10,i,jd)*dp)/pphi(1,i)
c                                    check for errors and use simple 
c                                    values on error
         if (pphi(1,i).lt.0d0.or.
     *       pphi(13,i).lt.0d0.or.pphi(14,i).lt.0d0) then 

            iwarn = 1
            itic = itic + 1
            pphi(1,i) = props(4,i,jd)
            pphi(13,i) = props(6,i,jd)/pphi(1,i)
            pphi(14,i) = -props(7,i,jd)/pphi(1,i)
         end if 
c                                    cpd entropy ds = cp/t*dt - V*alpha*dp
         pphi(15,i) = props(11,i,jd)  
c                                    + cp dlnt
     *              + pphi(12,i) * log( t/(t-dt) )
     *              - pphi(1,i)*pphi(13,i) * dp
c                                    cpd molar enthalpy, approx
         pphi(2,i) = (props(3,i,jd) 
c                                    + cp dt
     *              + dt * props(5,i,jd) 
c                                    + v dp 
     *              + dp * pphi(1,i))
c                                    system molar volume
         psys(1) = psys(1) + pphi(1,i)*wt 
c                                    molar enthalpy
         psys(2) = psys(2) + pphi(2,i)*wt 
c                                    molar heat capacity
         psys(12) = psys(12) + pphi(12,i)*wt 
c                                    molar expansivity
         psys(13) = psys(13) + pphi(13,i)*wt 
c                                    molar compressibility
         psys(14) = psys(14) + pphi(14,i)*wt 
c                                    molar entropy
         psys(15) = psys(15) + pphi(15,i)*wt 

         if (iflu(jd).eq.1) then 
c                                    assemblage includes fluid
            if (iflug(i,jd).eq.0) then
c                                    get total without fluid
               psys1(1) = psys1(1) + pphi(1,i)*wt 
c                                    molar enthalpy
               psys1(2) = psys1(2) + pphi(2,i)*wt 
c                                    molar heat capacity
               psys1(12) = psys1(12) + pphi(12,i)*wt 
c                                    molar expansivity
               psys1(13) = psys1(13) + pphi(13,i)*wt 
c                                    molar compressibility
               psys1(14) = psys1(14) + pphi(14,i)*wt 
c                                    molar entropy
               psys1(15) = psys1(15) + pphi(15,i)*wt 
            end if 
         end if 
      end do 
c                                    total volume now can be used
c                                    for second loop
      do i = 1, jbulk
c                                    cpd id:
         id = idbk(i,jd)
c                                    volume fraction
         pphi(11,i) = props(1,i,jd)*pphi(1,i)/psys(1)      
c                                    ------------------------------------
c                                    create derivative properties:
c                                    for each compound:     
  
c                                    Thermal Grueneisen Ratio (dimensionless)
         pphi(3,i) = pphi(1,i)/
     *                      (pphi(12,i)*pphi(14,i)/pphi(13,i) - 
     *                      t*pphi(13,i)*pphi(1,i))

         ierr = 0 
c                                     check for weird volume stuff
         if (pphi(3,i).lt.0e0.or.pphi(13,i).lt.0e0) then
            ierr = 1 
            iwarn = 1
         end if

         if (pphi(1,i).lt.0e0) then 
            if (ierr.eq.1) ierr = 3
            ierr = 2
            iwarn = 1
         end if
c                                    Shear Modulus (bar)
         pphi(5,i) = props(12,i,jd) + dp*props(13,i,jd) 
     *                              + dt*props(14,i,jd)
c                                    this is the old version, for taras
c        pphi(5,i) = props(12,i,jd) + (p-1)*props(13,i,jd) 
c     *                              + (t-300d0)*props(14,i,jd)
c                                    stixtrudes EoS may give bad shear mod
         if (pphi(5,i).le.0d0) then 
            pphi(5,i) = 0d0
            ierr = 5
            iwarn = 1
         end if 

         if (ierr.eq.0) then 
c                                    no weird volume problems:
c                                    Adiabatic Bulk Modulus (bar)
            pphi(4,i) = (1d0 + t*pphi(13,i)
     *                          *pphi(3,i))/pphi(14,i)
c                                    density (kg/m3)
            pphi(10,i) = props(2,i,jd)/pphi(1,i)*1e2
c                                    p-wave velocity
            pphi(7,i) = dsqrt((pphi(4,i)+4d0*pphi(5,i)/3d0)*1d5
     *                  /pphi(10,i))/1d3
c                                    s-wave velocity
            pphi(8,i) = dsqrt(pphi(5,i)*1d5/pphi(10,i))/1d3

            pphi(9,i) = pphi(8,i)/pphi(7,i)
c                                    sound velocity (km/s)
            pphi(6,i) = dsqrt(pphi(4,i)*1d5/pphi(10,i))/1d3

         else 
c                                    volume is negative and we are 
c                                    totally f'd
c                                    no weird volume problems:
c                                    Adiabatic Bulk Modulus (bar)
            pphi(4,i) = 1d9
c                                    density (kg/m3)
            pphi(10,i) = props(2,i,jd)/pphi(1,i)*1e2
            if (ierr.gt.1) pphi(10,i) = 1d0
c                                    p-wave velocity
            pphi(7,i) = 0d0
c                                    s-wave velocity
            if (ierr.eq.1) then 
               pphi(8,i) = dsqrt(pphi(5,i)*1d5/pphi(10,i))/1d3
            else 
               pphi(8,i) = 0d0
            end if 

            pphi(9,i) = 0d0
c                                    sound velocity (km/s)
            pphi(6,i) = 0d0

         end if 

         if (ikp(id).ne.iold.or.ikp(id).eq.0) then 
c                                    a new solution, initialize:
            nphi = nphi + 1
            rcpd  = 0d0
            idphi(nphi) = id
            iold = ikp(id)
            rcpd      = 0d0 
            twt(nphi) = 0d0
            vol       = 0d0
            enth      = 0d0
            rho       = 0d0
            cp        = 0d0
            alpha     = 0d0
            beta      = 0d0
            shearm    = 0d0
            vmode     = 0d0
            entr      = 0d0 
            swt(nphi) = 0d0
            do k = 1, jbulk
               scomps(nphi,k) = 0d0
            end do 
         end if 
c                                   sum properties
         rcpd      = rcpd + 1d0
         wt        = props(1,i,jd)
         if (wt.lt.0d0) wt = 0d0
         swt(nphi) = swt(nphi) + cwt(i)
         twt(nphi) = twt(nphi) + wt    
         vol       = vol + wt * pphi(1,i)
         enth      = enth + wt * pphi(2,i)
         rho       = rho + wt * pphi(10,i)
         cp        = cp  + wt * pphi(12,i)
         alpha     = alpha + wt * pphi(13,i) 
         beta      = beta + wt * pphi(14,i)
         shearm    = shearm + wt *pphi(5,i)
         entr      = entr + wt * pphi(15,i)
         do k = 1, jbulk
            scomps(nphi,k) = scomps(nphi,k) + wt * comps(id,k)
         end do 
c                                    number of non-fluid compounds with shear moduli
         if (pphi(5,i).ne.0d0.and.iflug(i,jd).eq.0) jtic = jtic + 1
c                                    if fluid is present, then the number of fluid
c                                    compunds
         if (iflu(jd).eq.1.and.iflug(i,jd).eq.1) ktic = ktic + 1

         vmode  = vmode + pphi(11,i)

         if (i.eq.jbulk.or.ikp(id).eq.0) then 
            iend = 1
         else if (ikp(idbk(i+1,jd)).ne.iold) then 
            iend = 1
         else 
            iend = 0 
         end if 

         if (iend.eq.1.and.twt(nphi).gt.0d0) then 
c                                    compute phase props:
            sphi(1,nphi)  = vol/twt(nphi)
            sphi(2,nphi)  = enth/twt(nphi)
            sphi(5,nphi)  = shearm/twt(nphi)
            sphi(10,nphi) = rho/twt(nphi)
            sphi(11,nphi) = vol/psys(1) 
            sphi(12,nphi) = cp/twt(nphi)
            sphi(13,nphi) = alpha/twt(nphi)
            sphi(14,nphi) = beta/twt(nphi)
            sphi(15,nphi) = entr/twt(nphi)
            if (iopt(2).eq.0) then 
c                                    we want molar phase compositions
               do k = 1, jbulk
                  scomps(nphi,k) = scomps(nphi,k)/twt(nphi)
               end do 
            else 
c                                    weight compositions:
               rwt = 0d0
               do k = 1, jbulk
                  scomps(nphi,k) = scomps(nphi,k)*atwt(k)
                  rwt = rwt + scomps(nphi,k)
               end do        
               do k = 1, jbulk
                  scomps(nphi,k) = scomps(nphi,k)/rwt*1d2
               end do         
            end if 
c                                    Thermal Grueneisen Ratio (dimensionless)
            sphi(3,nphi) = sphi(1,nphi)/
     *                  (sphi(14,nphi)*sphi(12,nphi)/sphi(13,nphi) 
     *                  - t*sphi(13,nphi)*sphi(1,nphi))
c                   
            ierr = 0 
c                                     check for weird volume stuff
            if (sphi(3,nphi).lt.0d0.or.sphi(13,nphi).lt.0e0) then
               ierr = 1 
               iwarn = 1
            end if

            if (sphi(1,nphi).lt.0e0) then 
               if (ierr.eq.1) ierr = 3
               ierr = 2
               iwarn = 1
            end if

            if (ierr.eq.0) then 
c                                    no weird volume problems:
c                                    Adiabatic Bulk Modulus (bar)
               sphi(4,nphi) = (1d0 + t*sphi(13,nphi)*sphi(3,nphi))
     *                       /sphi(14,nphi)
c                                    p-wave velocity
               sphi(7,nphi) = dsqrt((sphi(4,nphi)+4d0*sphi(5,nphi)/3d0)
     *                            *1d5/sphi(10,nphi))/1d3
c                                    s-wave velocity
               sphi(8,nphi) = dsqrt(sphi(5,nphi)*1d5/sphi(10,nphi))/1d3

               sphi(9,nphi) = sphi(8,nphi)/sphi(7,nphi)
c                                    sound velocity (km/s)
               sphi(6,nphi) = dsqrt(sphi(4,nphi)*1d5/sphi(10,nphi))/1d3
            else 
c                                    no weird volume problems:
c                                    Adiabatic Bulk Modulus (bar)
               sphi(4,nphi) = 0d0
c                                    p-wave velocity
               sphi(7,nphi) = 0d0
c                                    s-wave velocity
               sphi(8,nphi) = 0d0

               sphi(9,nphi) = 0d0
c                                    sound velocity (km/s)
               sphi(6,nphi) = 0d0
            end if 
c                                    compute system sums:
c                                    These depend on weighting scheme,
c                                    here we use Voigt-Reuss-Hill.
c                                    Aggregate Gruneisen Ratio
            psys(3) = psys(3) + sphi(11,nphi)*sphi(3,nphi)*chi
            pgeo(3) = pgeo(3) + sphi(11,nphi)/sphi(3,nphi)
c                                    Aggregate Bulk Modulus                                
            psys(4) = psys(4) + sphi(11,nphi)*sphi(4,nphi)*chi
            pgeo(4) = pgeo(4) + sphi(11,nphi)/sphi(4,nphi)
c                                    Aggregate Sound
            psys(6) = psys(6) + sphi(11,nphi)*sphi(6,nphi)*chi
            pgeo(6) = pgeo(6) + sphi(11,nphi)/sphi(6,nphi)
c                                    Aggregate Vp                                
            psys(7) = psys(7) + sphi(11,nphi)*sphi(7,nphi)*chi
            pgeo(7) = pgeo(7) + sphi(11,nphi)/sphi(7,nphi)
c                                    Arithmetic means for mu and Vs
            psys(5) = psys(5) + sphi(11,nphi)*sphi(5,nphi)*chi
            psys(8) = psys(8) + sphi(11,nphi)*sphi(8,nphi)*chi

            if (iemod(jd).eq.jbulk) then 
c                                    Aggregate Shear Modulus, only
c                                    if shear mod is available for all
c                                    cpds.
               pgeo(5) = pgeo(5) + sphi(11,nphi)/sphi(5,nphi)
c                                    Aggregate Vs                               
               pgeo(8) = pgeo(8) + sphi(11,nphi)/sphi(8,nphi)
            end if

            if (iflu(jd).eq.1) then 
c                                    compute totals without fluid:
               if (iflug(i,jd).eq.0) then 
c                                    renormalized fraction:
                  frac = sphi(11,nphi)*psys(1)/psys1(1)
c                                    Aggregate Gruneisen Ratio
                  psys1(3) = psys1(3) + frac*sphi(3,nphi)*chi
                  pgeo1(3) = pgeo1(3) + frac/sphi(3,nphi)
c                                     Aggregate Bulk Modulus                                
                  psys1(4) = psys1(4) + frac*sphi(4,nphi)*chi
                  pgeo1(4) = pgeo1(4) + frac/sphi(4,nphi)
c                                     Aggregate Sound vel                                
                  psys1(6) = psys1(6) + frac*sphi(6,nphi)*chi
                  pgeo1(6) = pgeo1(6) + frac/sphi(6,nphi)
c                                    Vp
                  psys1(7) = psys1(7) + frac*sphi(7,nphi)*chi
                  pgeo1(7) = pgeo1(7) + frac/sphi(7,nphi)
c                                    Arithmetic means for mu and Vs
                  psys1(5) = psys1(5) + frac*sphi(5,nphi)*chi
                  psys1(8) = psys1(8) + frac*sphi(8,nphi)*chi


                  if (sphi(5,nphi).ne.0d0) then 
c                                    Aggregate Shear Modulus, only
c                                    if shear mod is available for all
c                                    cpds.
                      pgeo1(5) = pgeo1(5) + frac/sphi(5,nphi)
c                                    Vs
                      pgeo1(8) = pgeo1(8) + frac/sphi(8,nphi)
                 end if
              end if 
            end if 
         end if 

      end do 

      psys(3) = psys(3) + chi1/pgeo(3)
      psys(4) = psys(4) + chi1/pgeo(4)
c                                    density
      psys(10) = ptot(2,jd)/psys(1)*1e2
c                                    sound velocity
      psys(6) = dsqrt(psys(4)*1d5/psys(10))/1d3
c                                    p-wave velocity
      psys(7) = psys(7) + chi1/pgeo(7)

      if (iemod(jd).eq.jbulk) then 
c                                    there are shear moduli for every phase:
c                                    shear modulus
         psys(5) = psys(5) + chi1/pgeo(5)
c                                    s-wave velocity
         psys(8) = psys(8) + chi1/pgeo(8)
         psys(9) = psys(8)/psys(7)

      else if (ktic+jtic.eq.jbulk) then 
c                                    shear moduli for everything but fluid
c                                    then don't add harmonic mean:
c                                    shear modulus
         psys(5) = psys(5)/chi
c                                    s-wave velocity
         psys(8) = psys(8)/chi 
         psys(9) = psys(8)/psys(7)
      else 
         ikrank = 1
         psys(5) = 0d0
         psys(7) = 0d0
         psys(8) = 0d0
         psys(9) = 0d0
      end if 

      if (iflu(jd).eq.1) then 
c                                    assemblage contains fluid, compute
c                                    fluid absent properties:
c                                    molar volume
         psys1(3) = psys1(3) + chi1/pgeo1(3)
         psys1(4) = psys1(4) + chi1/pgeo1(4) 
c                                    sound velocity
         psys1(6) = psys1(6) + chi1/pgeo1(6)
         psys1(10) = ptot1(2,jd)/psys1(1)*1e2

         if (jtic.eq.jbulk-ktic) then 
c                                    shear modulus
            psys1(5) = psys1(5) + chi1/pgeo1(5)
c                                    p-wave velocity
            psys1(7) = psys1(7) + chi1/pgeo1(7)
c                                    s-wave velocity
            psys1(8) = psys1(8) + chi1/pgeo1(8)

            psys1(9) = psys1(7)/psys1(8)
         else 
            psys1(5) = 0d0
            psys1(7) = 0d0
            psys1(8) = 0d0
         end if 

         psys1(6) = dsqrt(psys1(4)*1d5/psys1(10))/1d3
         
      end if 

99    if (iwarn.eq.1.and.itic.lt.100) then 
         itic = itic + 1
         write (*,1000) t,p

         if (itic.eq.100) then 
            write (*,*) 'this warning will not be repeated for future'
            write (*,*) 'instances of this problem'
         end if 
      end if 


1000  format ('**WARNING** at T(K)=',g12.4,' P(bar)=',g12.4,' a phase',
     *       /,'has invalid physical properties, this may result in',/,
     *         'incorrect densities and seismic velocities. this error'
     *      ,/,'can usually be avoided by turning compression off ',/,
     *         'when you run VERTEX (set JTEST=3)',/)
      end 

      subroutine readop 
c----------------------------------------------------------------------
c readop - readop looks for the werami_option.dat file, if it finds
c the option file it scans the file for keywords and sets options
c accordingly.
c----------------------------------------------------------------------
      implicit none

      integer lun, ier, iopt

      character*3 key, val, value(10), nval*12

      save lun

      data lun/13/

      common / opts /iopt(10)

c                                   default option values:
      iopt(1) = 0
      value(1) = 'off'
      iopt(2) = 0 
      value(2) = 'mol'
      iopt(3) = 0 
      value(3) = 'vol'
c                                   look for file
      open (lun, file = 'werami_option.dat', iostat = ier, 
     *      status = 'old')
c                                   no option file, set defaults
      if (ier.ne.0) goto 99
c                                   read cards to end of 
c                                   option file
      do while (ier.eq.0) 

         call readcd (lun,ier,key,val,nval)
c                                   ier ne 0 bad record or eof
         if (ier.ne.0) exit 
c                                   if here we should have a keyword and
c                                   value
         if (key.eq.'ave') then
c                                   average pseudocompounds key
            if (val.eq.'on') then
               iopt(1) = 1
            else if (val.eq.'off') then 
               iopt(1) = 0 
            else 
               iopt(1) = 2
            end if 
            value(1) = val
         else if (key.eq.'com') then 
c                                   phase composition key
            if (val.eq.'wt') then
               iopt(2) = 1
            else 
               iopt(2) = 0
            end if 
            value(2) = val
         else if (key.eq.'pro') then 
c                                   phase proportion key
            if (val.eq.'wt') then
               iopt(3) = 1
            else if (val.eq.'mol') then 
               iopt(3) = 2 
            else 
c                                   volume is default
               iopt(3) = 0
            end if 
            value(3) = val
         end if 
      end do 
                
99    close (lun)

      
      write (*,1000) 
      write (*,1010) value(1),value(2),value(3)
      write (*,1020)

1000  format (/,'Output options are currently set as:',//,
     *          '    Keyword:      Value:     Permitted values ',
     *          '[default]:')
1010  format (4x,'average       ',a3,8x,'on [off]',/,
     *        4x,'compositions  ',a3,8x,'wt [mol]',/,
     *        4x,'proportions   ',a3,8x,'wt [vol]',/)
1020  format ('To change these options edit or create',
     *        ' file werami_option.dat',/)

      end 

      subroutine readcd (lun,ier,key,val,nval)
c----------------------------------------------------------------------
c readcd - read 240 column card image from unit lun, strip out unwanted
c characters. ier = 1 -> eof.
c this routine seeks a card containg a keyword and a value (text), the
c first 3 letters of each is returned in char(1:6)
c----------------------------------------------------------------------    
      implicit none

      integer len, ier, iscan, i, iscnlt, ibeg, lun, iend

      character chars(240)*1, card*240, key*3, val*3, nval*12
 
      ier = 0 

      ibeg = 0
  
      len = 0 

      card = ''

      do while (ibeg.ge.len) 

         read (lun,'(a)',end=90) card

         if (card.ne.'') then 
            read (card,'(240a)') chars
c                                    find end of data marker '|'
            len = iscan (1,240,chars,'|') - 1
c                                    find a non blank character
            ibeg = iscnlt (1,len,chars,' ')
         end if 

      end do 

      iend = ibeg + 2
c                                    ok, we've got the keyword
c                                    load 3 chars of keyword into
      write (key,'(3a1)') (chars(i), i = ibeg, iend)
c                                    find next blank 
      iend = iscan (iend,240,chars,' ') 
c                                    now locate the value:
      ibeg = iscnlt (iend,len,chars,' ')
c                                    now find trailing blank
      iend = iscan (ibeg,240,chars,' ') 
c                                    now save a longer version in case
c                                    the value is numeric
      if (iend-ibeg.gt.11) iend = ibeg + 11
c                                    should check for error
      write (val,'(3a1)') (chars(i), i = ibeg, ibeg + 2)

      write (nval,'(12a1)') (chars(i), i = ibeg, iend)

      goto 99

90    ier = 1

99    end

      integer function iscan (ibeg,iend,chars,char)
c----------------------------------------------------------------------
      implicit none

      character chars(240)*1, char*1

      integer ibeg, iend

      do iscan = ibeg, iend

         if (chars(iscan).eq.char) exit

      end do 

      end 

      integer function iscnlt (ibeg,iend,chars,char)
c----------------------------------------------------------------------
      implicit none

      character chars(240)*1, char*1

      integer ibeg, iend


      do iscnlt = ibeg, iend

         if (chars(iscnlt).gt.char) exit

      end do 

      end 