 
c Copyright (c) 1990 by James A. D. Connolly, Institute for Mineralogy and
c Petrography, Swiss Federal Insitute of Technology, CH-8092 Zurich,
c SWITZERLAND. All rights reserved.
 
c PSVDRAW - a program to generate postscript code for x-y plots and chemographic
c phase diagrams.  The input data format is consistent with the files generated
c by the programs VERTEX and FRENDLY.
 
c Please do not distribute any part of this source.
 
 
      PROGRAM PVDRAW
 
      implicit real (a-g,o-z),integer (h-n)
 
      character*100 fname, yes*1, xname
 
      common / basic /n4,ifont,icopt,jwidth,iop0
      common / xyrat /xfac/ cst321 /interp
      common / opts /iopt(10)
c                                    set default output options
c                                    could call readop to do this
c                                    but would probably add to user
c                                    confusion:
      iopt(1) = 0
      iopt(2) = 0 
      iopt(3) = 0 

      n4 = 24
c                                    default font
      ifont = 7
c                                    default line width
      jwidth = 1
 
      write (*,1020) 
      read (*,1000) fname
      xname = fname
 
      open (n4,err=90,file=fname,status='old')

      read (n4,*,err=91) icopt

20    call psopen (fname,ier)
      goto (999), ier
  
30    if (icopt.ne.0) then 
         write (*,1030) 
         read (*,1000) yes
         iop0 = 0
         if (yes.eq.'y'.or.yes.eq.'Y') iop0 = 1
      end if 
  
      if (icopt.eq.1.or.icopt.eq.6.or.icopt.eq.5.or.icopt.eq.7
     *              .or.icopt.eq.9) then

         interp = 0
         if (icopt.eq.7.or.icopt.eq.9) then
            icopt = 5
            interp = 1
         end if 
         xfac = 1.0
         call psxypl (xname)
 
      else if (icopt.eq.0) then
 
         call pschem 
 
      else if (icopt.eq.3) then
 
         xfac = 0.5
         call psmixd 

      else  
 
         goto 91
 
      end if
 
      goto 99
90    write (*,1040) fname
      goto 999
91    write (*,1050) fname
      goto 999
 
99    call psclos
 
      close (99)
 
1000  format (a)
1020  format (/,'Enter the Perple_X plot file name:')
1030  format ('Modify the default plot (y/n)?')
1040  format (/,'No such file as:',/,a,/)
1050  format ('File:',/,a,/,'is not formatted correctly for PSVDRAW.',/)

999   end
c---------------------------------------------------------------------
      subroutine psxypl (xfname)
 
c psxypl - subroutine to output x-y plot.

      implicit real (a-g,o-z),integer (h-n)
 
      character xfname*100
 
      include 'perplex_parameters.h'
 
      parameter (l3=l2+2)

      common/ vs    /vmin(l3),vmax(l3),iv
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / basic /n4,ifont,icopt,jwidth,iop0
c                                 rewind n4, cause icopt was already read
      rewind (n4)
c                                 read plot file header
      call plinp (tmin,tmax,pmin,pmax)
c                                 read assemblage file
      if (icopt.gt.4) call bplinp (xfname,kpoly)
c                                 get user options and read
c                                 rest of plot file, draw data
      call psdplt (xfname,jop0)         
c                                 draw axes
      call psaxes (jop0)

99    end
c----------------------------------------------------------------------
      subroutine psaxop (jop0,iop1,iop8,fac)

c psaxop - subroutine to make graphics transformation and get some options

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      character yes*1, vname*8

      parameter (l3=l2+2)

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ xyrat /xfac/ basic /n4,ifont,icopt,jwidth,iop0


      dsx = 0.18
      dsy = 0.18
      dtx = 160.
      dty = 220.
      drot = 0.
      jop0 = 0
      iop8 = 1
      jwidth = 1 
      fac = 0.6

      if (icopt.ne.3.and.iop0.eq.1) then
c                                     modify default drafting
c                                     options?          
         write (*,1090) 
         read (*,1030) yes
         if (yes.eq.'y'.or.yes.eq.'Y') jop0 = 1

      else if (icopt.eq.3) then

         jop0 = iop0

      end if 

      if (jop0.eq.1) then

         if (icopt.eq.3.or.icopt.eq.5) goto 10  
c        if (icopt.eq.3) goto 10 

         write (*,1070) 
         read (*,1030) yes
         iop1 = 0
 
         if (yes.eq.'y'.or.yes.eq.'Y') then
            write (*,1040) vname(1),vmin(1),vmax(1)
            read (*,*) vmin(1),vmax(1)
            write (*,1040) vname(2),vmin(2),vmax(2)
            read (*,*) vmin(2),vmax(2)
            iop1 = 1
            write (*,1080) 
         end if

10       write (*,1100)
         read (*,1030) yes

         if (yes.eq.'y'.or.yes.eq.'Y') then

            write (*,1110) dsx,dsy,dtx,dty,drot
            read (*,*) dsx,dsy,dtx,dty,drot

         end if 

         write (*,1130)
         read (*,1030) yes

         if (yes.eq.'y'.or.yes.eq.'Y') then

            write (*,1140) 
            read (*,*) xfac

         end if 

20       write (*,2000)
         read (*,1030) y
         if (yes.eq.'y'.or.yes.eq.'Y') then 
            write (*,2020) 
            read (*,*) fac
            if (fac.le.0.) then
               write (*,1200) fac
               goto 20 
            end if
         end if 

         if (icopt.eq.3) goto 30 

         write (*,1120) 
         read (*,1030) yes
         if (yes.eq.'y'.or.yes.eq.'Y') jwidth = 0
c                                       splines, yes = 0
         write (*,1210) 
         read (*,1030) yes
         if (yes.ne.'y'.and.yes.ne.'Y') iop8 = 0
 
      end if

30    xmax = vmax(1)
      xmin = vmin(1)
      ymax = vmax(2)
      ymin = vmin(2)
      xlen = xmax - xmin
      ylen = ymax - ymin
c                                     set default char size, based
c                                     on font 7 (helv 14) the axes
c                                     length is about 85 characters
      dcx = xlen / 85.
      dcy = ylen / 85.
 
      call psssc2 (xmin,xmax,ymin,ymax)

      dsx = dsx * xfac
 
      call psstrn (dsx,dsy,dtx,dty,drot)

1030  format (a1)
1040  format (/,'Enter new min and max for ',a8,' old values ',
     *        ' were: ',2(g11.5,1x))
1070  format (/,'Modify x-y limits (y/n)? ')
1080  format ('OK, but this may look sloppy. ')
1090  format (/,'Modify default drafting options (y/n)?',/,
     *          '  answer yes to modify:',/,
     *          '   - picture transformation',/,
     *          '   - x-y plotting limits',/,
     *          '   - relative lengths of axes',/,
     *          '   - text label font size',/,
     *          '   - line thickness',/,
     *          '   - curve smoothing',/,
     *          '   - axes labeling and gridding')
1100  format (/,'Modify default picture transformation (y/n)?')
1110  format (/,'The default values for x-y scaling, x-y',
     *          ' translation, and rotation',/,' are, respectively:',
     *        /,(5(4x,g8.3)),/,'Enter the new values: ')
1120  format (/,'Use minimum width lines (y/n)?')
1130  format (/,'Modify ratio of x to y axis length (y/n)')
1140  format (/,'Enter fractional length of x axis relative',
     *          ' to the y axis: ')
1200  format (/,g13.6,' is an invalid value.',/)
1210  format (/,'Fit curves with B-splines (y/n)? ')
2000  format (/,'Modify default text scaling (y/n)? ')
2020  format (/,'Enter the scaling factor: ')

      end 
c----------------------------------------------------------------------
      subroutine pschem
 
c pschem - subroutine to output ternary chemographies.

      implicit real (a-g,o-z),integer (h-n)
 
      include 'perplex_parameters.h'
 
      character names*8, vname*8, title*162, record*72, yes*1, 
     *          sname*10, xname(k5)*8
 
      real x3(3), y3(3), xx(1000), yy(1000)
 
      integer idss(10), iperm(2,3)
 
      parameter (l3=l2+2)

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
      common/ basic /n4,ifont,icopt,jwidth,iop0
      common/ cst8  /names(k1)/ csta7 /sname(h9)/ phase /ikp(k1)
      common/ asmbl /idf(3,k2),ib,iasmbl(k2),ivchk(k1),x(2,k1)
 
      save x3,y3,dyt,yt,xt,iperm
 
      data x3,y3,dyt,yt,xt,iperm/0.0,0.5,1.0,0.0,0.866025,0.0,
     *     300.,980.,100.,1,2,1,3,2,3/
c                                  -----------------------------------------------
c                                  read header information 
      read (n4,*) icp,istct,iphct,ipoint,ifyn,isyn,ipot,isoct

      if (icp.ne.3) then 
         write (*,*) 'Sorry, PSVDRAW only works',
     *               ' for ternary composition diagrams.'
         stop
      end if 
 
      if (iphct.gt.k1.or.iv.gt.5
     *                 .or.ib.gt.k2.or.ipot.gt.5) then
         write (*,*) 'dimensioning error in pschem'
         goto 99
      end if

      read (n4,1000) (vname(i),i=1,ipot)
      read (n4,1000) title
c                                  names
      read (n4,1020) (names(i), i = 1, iphct)
c                                  phase coordinates
      read (n4,*) ((x(j,i),j = 1, 2), i=istct, iphct)
      read (n4,*) (ikp(i), i = 1, iphct)
c                                  solution names
      if (isoct.ne.0) read (n4,1090) (sname(i),i = 1, isoct)
c                                  write graphics code names for x variables:
      read (n4,1020) (xname(i), i = 1, icp)
c                                  -----------------------------------------------
c                                  convert to equilateral coordinates:
      do i = istct, iphct
         x(1,i) = x(1,i) + 0.5 * x(2,i)
         x(2,i) = x(2,i) * 0.866025
      end do 
c                                  draw tie lines?
      write (*,1060)
      read (*,1070) yes
      iop1 = 0
c                                  iop1 = 1 = yes
      if (yes.eq.'y'.or.yes.eq.'Y') iop1 = 1   
      iflag = 0
c                                  read simple variables
10    read (n4,*,end=99) (vmin(i), i = 1, ipot)
      read (n4,*) ib
c                                  read phase configurations   
      read (n4,*) ((idf(j,i),j = 1, icp), i = 1, ib)
 
      do i = 1, iphct
         ivchk(i) = 0 
      end do 
c                                  read assemblage flags
      read (n4,*) (iasmbl(i), i = 1, ib)
c                                  read saturated phase id's
      if (isyn.ne.1) then 
         read (n4,*) isat
         read (n4,*) (idss(i), i = 1, isat)
      end if 
 
      iflag = (iflag-1)**2
 
      if (iflag.eq.0) then
         xt = 375.
      else
         yt = yt - dyt
         xt = 75.
      end if
 
      call psssc2 (0.,1.,0.,1.)
 
      call psstrn (0.08,0.08,xt,yt,0.)

      if (iop1.eq.0) then 
c                                  don't draw tielines
c                                  first divariant 
         do i = 1, ib                      
            if (iasmbl(i).eq.3) then
               call merger (i,iperm,ivert,ipoint,xx,yy)
               call pspygn (xx,yy,ivert,0.,0,7)
            end if
         end do
c                                  second miscibility
         do i = 1, ib                      
            if (iasmbl(i).eq.4) then
               call merger (i,iperm,ivert,ipoint,xx,yy)
               call pspygn (xx,yy,ivert,1.,0,0)
            end if
         end do
c                                  third univariant
         do i = 1, ib                      
            if (iasmbl(i).eq.2) then
               call merger (i,iperm,ivert,ipoint,xx,yy)
               call pspygn (xx,yy,ivert,1.,0,3)
            end if
         end do
c                                  last invariant
         do i = 1, ib                      
            if (iasmbl(i).eq.1) then
               do j = 1, 3
                  id = idf(j,i)
                  ivchk(id) = 1
                  xx(j) = x(1,id) 
                  yy(j) = x(2,id) 
               end do
               call pspygn (xx,yy,3,1.,0,0)
            end if
         end do   

      else 
c                                  old mode, draw tielines:
         do i = 1, ib
 
            ias = iasmbl(i)
 
            do j = 1, 3
               id = idf(j,i)
               if (ias.eq.1.or.id.le.ipoint) ivchk(id) = 1
               xx(j) = x(1,id) 
               yy(j) = x(2,id) 
            end do
 
            rias = float(ias)
c                                           draw tie lines:
            if (ias.eq.1) then
c                                           invariant
               call pspygn  (xx,yy,3,rias,0,0)
            else if (ias.eq.2) then
c                                           univariant
               call pspygn  (xx,yy,3,rias,0,0)
c                                           draw a thin line
c                                           between pseudocompounds of the
c                                           same phase
               do j = 1, 3
                  id = idf(iperm(1,j),i)
                  jd = idf(iperm(2,j),i)
c                                           draw the line:
                  if (ikp(jd).eq.ikp(id)) call psline 
     *               (xx(iperm(1,j)),yy(iperm(1,j)),
     *                xx(iperm(2,j)),yy(iperm(2,j)),1.,0)
               end do
            else if (ias.eq.3) then
c                                           divariant
               call pspygn  (xx,yy,3,rias,0,7)
            else if (ias.eq.4) then
c                                           immiscibility
               call pspygn  (xx,yy,3,rias,0,0)
            end if 

         end do 

      end if
 
      do i = istct, iphct
         if (ivchk(i).ne.0) then
            call pssctr (8,1.2,1.2,0.)
            x1 = x(1,i) + 0.015
            y1 = x(2,i) 
            call pstext (x1,y1,names(i),8)
            call pselip (x1-0.015,y1,0.007,0.007,0.,0,7)
         end if
      end do
c                                       draw bounding triangle
      call pspygn  (x3,y3,3,1.,0,0)
c                                       sectioning constraints
         call pssctr (8,1.2,1.2,0.)
         y = 1.
         do i = 1, ipot
            write (record,1040) vname(i),vmin(i)
            nchar = 0 
            call psublk (record,nchar)
            call pstext (0.75,y,record,nchar)
            y = y - 0.06
         end do 
 
         if (ifyn.eq.0) then 
            call pstext (0.75,y,'(fluid saturated)',17)
            y = y - 0.06
         end if 

         if (isyn.eq.0) then
            write (record,1050) (names(idss(i)),i=1,isat)
            nchar = 72 
            call psublk (record,nchar)
            call pstext (0.75,y,record,nchar)
         end if 
 
      goto 10

1000  format (a)
1020  format (10a8)
1030  format (bn,i80)
1040  format (a8,'=',g9.3)
1050  format ('+ ',6(a8,' '))
1060  format ('Draw tielines (y/n[recommended])?')
1070  format (a1)
1090  format (8a10)
 
99    end

      subroutine merger (i,iperm,ivert,ipoint,xx,yy)

      implicit real (a-g,o-z),integer (h-n)
 
      include 'perplex_parameters.h'
 
      real xx(l5), yy(l5)
 
      integer iperm(2,3), idv(1000), idp(3), jdv(3)

      common/ asmbl /idf(3,k2),ib,iasmbl(k2),ivchk(k1),x(2,k1)
     *      / phase /ikp(k1)
c                                    merge high variance fields
c                                    load first part into polygon:
      ias = iasmbl(i)
      ivert = 3

      do j = 1, 3
         id = idf(j,i)
         idv(j) = id
c                                    identify the phases
         if (ikp(id).ne.0) then 
            idp(j) = -ikp(id)
c                                    tag used endmember compounds:
            if (id.le.ipoint) then
               ivchk(id) = 1
            end if 
         else 
            idp(j) = id
c                                    tag used compounds:
            ivchk(id) = 1
         end if 
      end do
c                                    now search for the common simplexes:
50    do 20 j = 1, ib

         jas = iasmbl(j)
c                                    no match, reject:
         if (jas.ne.ias.or.j.eq.i) goto 20

         do 30 k = 1, 3
            id = idf(k,j)
            jdv(k) = id
c                                    check if the phases match: 
            if (ikp(id).ne.0) then 
               if (id.lt.ipoint) ivchk(id) = 1
               do l = 1, 3
                  if (-ikp(id).eq.idp(l)) goto 30
               end do 
c                                    no match, reject:
               goto 20                    
            else 
               do l = 1, 3
                  if (id.eq.idp(l)) goto 30
               end do
c                                    no match, reject:
               goto 20
            end if 
30       continue
c                                    ok, the simplex has the same assemblage
c                                    now match vertices:
         jvert = ivert 

         do k = 1, ivert
            if (k.lt.ivert) then 
               kp = k + 1
            else
               kp = 1
            end if 

            do l = 1, 3
               if (jdv(iperm(1,l)).eq.idv(k).and.
     *             jdv(iperm(2,l)).eq.idv(kp).or.
     *             jdv(iperm(2,l)).eq.idv(k).and.
     *             jdv(iperm(1,l)).eq.idv(kp)) then
                  if (kp.eq.1) then
c                                    tag the common join on the end
                     idv(ivert+1) = jdv(4-l)
                  else 
c                                    the simplex might share the next
c                                    segment as well:
                     if (ias.gt.2) then 
                        if (kp.lt.ivert) then
                           kp2 = kp + 1
                        else 
                           kp2 = 1
                        end if 

                        do ll2 = 1, 3
                           if (jdv(iperm(1,ll2)).eq.idv(kp).and.
     *                         jdv(iperm(2,ll2)).eq.idv(kp2).or.
     *                         jdv(iperm(2,ll2)).eq.idv(kp).and.
     *                         jdv(iperm(1,ll2)).eq.idv(kp2)) then
c                                     the simplex matches two segments
c                                     remove the matched point
                              do ll3 = kp+1, ivert
                                 idv(ll3-1) = idv(ll3) 
                              end do 
                              iasmbl(j) = -1
                              jvert = jvert - 1
                              goto 40 
                           end if 
                        end do 
                     end if 
c                                    found a common join, displace the old vertices
                     do ll1 = ivert + 1, kp, -1
                        idv(ll1) = idv(ll1-1)
                     end do
c                                    insert the new vertex
                     idv(kp) = jdv(4-l)
                  end if 
c                                    reset the assemblage flag:
                  iasmbl(j) = -1 
                  jvert = ivert + 1
                  goto 40 
               end if 
            end do 
         end do 

20    continue
c                                    if got to here then there were no
c                                    no matches, save the polygon
      do j = 1, ivert
c                                    the polygon now has ivert vertices
c                                    load the vertices
         if (idv(j).eq.0) cycle

         xx(j) = x(1,idv(j))
         yy(j) = x(2,idv(j))

      end do 

      goto 99
c                                    if here found a match, check the 
c                                    list for more
40    ivert = jvert 
      goto 50

99    end 

c----------------------------------------------------------------------
      subroutine psaxes (jop0)
 
c psaxes - subroutine to output (sloppy) axes.

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'
 
      character*8 vname, record*20, yes*1
 
      parameter (l3=l2+2)

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ xyrat /xfac/ basic /n4,ifont,icopt,iwidth,iop0
 
      ihalf = 1
      itenf = 0
      igrd = 0
      rline = 1.

      csn = 1.
      csa = 1.

      x0 = xmin
      y0 = ymin
      dx = xlen / 5.
      dy = ylen / 5.

      xtic  = xlen/45.
      xtic1 = xtic*.67
      xtic2 = xtic1*.67
 
      ytic  = ylen/45.
      ytic1 = ytic*.67
      ytic2 = ytic1*.67 

      if (jop0.eq.1) then
         write (*,1010) 
         read (*,1020) yes
         if (yes.ne.'y'.and.yes.ne.'Y') goto 10

         write (*,1030) 'X', x0, dx
         read (*,*) x0, dx
         write (*,1030) 'Y', y0, dy
         read (*,*) y0, dy

         write (*,1040)
         read (*,1020) yes
         if (yes.eq.'y'.or.yes.eq.'Y') ihalf = 0

         write (*,1050) 
         read (*,1020) yes
         if (yes.eq.'y'.or.yes.eq.'Y') itenf = 1

         write (*,1070) 
         read (*,1020) yes
         if (yes.eq.'y'.or.yes.eq.'Y') then 
            write (*,1060) 
            read (*,*) csn, csa
         end if

         write (*,1080) 
         read (*,1020) yes 
         if (yes.eq.'y'.or.yes.eq.'Y') igrid = 1    
      end if 
c                                       draw axes box
10    call psrect (xmin,xmax,ymin,ymax,1.,iwidth,0)
c                                       draw left vertical axis tics
      call psytic (xmin, y0, dy, xtic, xtic1, xtic2, rline, 
     *             ihalf, itenf)
c                                       draw right vertical axis
      call psytic (xmax, y0, dy, -xtic, -xtic1, -xtic2, rline, 
     *             ihalf, itenf)
c                                       draw bottom horizontal axis
      call psxtic (ymin, x0, dx, ytic, ytic1, ytic2, rline,
     *             ihalf, itenf)
c                                       draw top horizontal axis
      call psxtic (ymax, x0, dx, -ytic, -ytic1, -ytic2, rline, 
     *             ihalf, itenf)
 
      call pssctr (7,csn*1.2,csn*1.2,0.)

      cx = dcx * csn
      cy = dcy * csn 
c                                       numeric axis labels:
      call psylbl (xmin, xmax, y0, ymax, dy, cx, cy, tmin, igrd) 
 
      call psxlbl (x0, dx, cx, 2.3*cy, igrd)

      cx = dcx * csa
      cy = dcy * csa
c                                       x-axis name
      call pssctr (7,csa*2.,csa*2.,0.0)
      t = xmin + 0.5 * xlen - (7. * cx) / xfac
      call pstext (t, ymin - 0.07 * ylen, vname(1),0)
c                                       y-axis name
      call pssctr (7,csa*2.,csa*2., 90.)
      t = tmin - 5. * cx / xfac 
      call pstext (t, ymin + 0.43 * ylen,vname(2),0)
c                                       sectioning constraints
      if (iv.gt.2) then
 
         call pssctr (8,csa*1.2,csa*1.2,0.)
         y = ymax + 0.12 * ylen
         do 1 i = 3, iv
            write (record,1000) vname(i),vmin(i)
            call pstext (xmin,y,record,0)
1           y = y - 0.037 * ylen
 
      end if
 
1000  format (a,'=',g9.3)
1010  format (/,'Modify default axes (y/n)?')
1020  format (a)
1030  format (/,'Enter the starting value and interval for',
     *          ' major tick marks on',/,'the ',a,'-axis (the',
     *          ' current values are:',2(1x,g9.3),')',/, 
     *          ' Enter the new values:')
1040  format (/,'Cancel half interval tick marks (y/n)?')
1050  format (/,'Draw tenth interval tick marks (y/n)?')
1060  format (/,'Enter scale factors for numeric and text',
     *          ' axes labels:') 
1070  format (/,'Rescale axes text (y/n)?')
1080  format (/,'Turn gridding on (y/n)?')
      end

      subroutine psytic (x0, y0, dy, tic, tic1, tic2, rline, ihalf,
     *                   itenf)

      implicit real (a-g,o-z),integer (h-n)

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ basic /n4,ifont,icopt,iwidth,iop0

c psytic - subroutine to draw y-axis ticks.

      y = y0 
      call psmove (x0,y0)

      if (ihalf.eq.0.and.itenf.eq.0) then 

10       if (y.ge.ymax) goto 99
         call psrlin (tic,0.,rline,iwidth)
         call psrmov (-tic,dy)
         y = y + dy 
         goto 10

      else if (itenf.eq.0) then

         dy2 = dy / 2.

20       if (y.ge.ymax) goto 30
         call psrlin (tic,0.,rline,iwidth)
         call psrmov (-tic,dy2)
         y = y + dy2
         if (y.ge.ymax) goto 30
         call psrlin (tic1, 0., rline, iwidth)
         call psrmov (-tic1,dy2)
         y = y + dy2
         goto 20

30       if (y0-dy2.gt.ymin)
     *      call psline (x0,y0-dy2,x0+tic1,y0-dy2,rline,iwidth)
         goto 99

      else

         dy2 = dy / 10.

40       if (y.ge.ymax) goto 50
         call psrlin (tic, 0., rline, iwidth)
         call psrmov (-tic, dy2)
         y = y + dy2

         do 60 i = 1, 4
            if (y.ge.ymax) goto 50
            call psrlin (tic2, 0., rline, iwidth)
            call psrmov (-tic2, dy2)
60          y = y + dy2

         if (y.ge.ymax) goto 50
         call psrlin (tic1, 0., rline, iwidth)
         call psrmov (-tic1, dy2)
         y = y + dy2

         do 70 i = 1, 4
            if (y.ge.ymax) goto 50
            call psrlin (tic2, 0., rline, iwidth)
            call psrmov (-tic2, dy2)
70          y = y + dy2

         goto 40

50       if (y0-dy2.lt.ymin) goto 99

         y = y0 - dy2
         call psmove (x0,y)

         do 80 i = 1, 4
            if (y.le.ymin) goto 99
            call psrlin (tic2, 0., rline, iwidth)
            call psrmov (-tic2, -dy2)
80          y = y - dy2

         if (y.le.ymin) goto 99
         call psrlin (tic1, 0., rline, iwidth)
         call psrmov (-tic1, -dy2)
         y = y - dy2 

         do 90 i = 1, 4
            if (y.le.ymin) goto 99
            call psrlin (tic2, 0., rline, iwidth)
            call psrmov (-tic2, -dy2)
90          y = y - dy2

      end if 

99    end

c------------------------------------------------------------------
      subroutine psxtic (y0, x0, dx, tic, tic1, tic2, rline, ihalf,
     *                   itenf)

      implicit real (a-g,o-z),integer (h-n)

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ basic /n4,ifont,icopt,iwidth,iop0

c psxtic - subroutine to draw x-axis ticks.

      x = x0 
      call psmove (x0,y0)

      if (ihalf.eq.0.and.itenf.eq.0) then 

10       if (x.ge.xmax) goto 99
         call psrlin (0., tic, rline, iwidth)
         call psrmov (dx, -tic)
         x = x + dx 
         goto 10

      else if (itenf.eq.0) then

         dx2 = dx / 2.

20       if (x.ge.xmax) goto 30
         call psrlin (0., tic, rline, iwidth)
         call psrmov (dx2, -tic)
         x = x + dx2
         if (x.ge.xmax) goto 30
         call psrlin (0., tic1, rline, iwidth)
         call psrmov (dx2, -tic1)
         x = x + dx2
         goto 20

30       if (x0-dx2.gt.xmin)
     *      call psline (x0-dx2, y0, x0-dx2, y0+tic1, rline, iwidth)
         goto 99

      else

         dx2 = dx / 10.

40       if (x.ge.xmax) goto 50
         call psrlin (0., tic, rline, iwidth)
         call psrmov (dx2, -tic)
         x = x + dx2

         do 60 i = 1, 4
            if (x.ge.xmax) goto 50
            call psrlin (0., tic2, rline, iwidth)
            call psrmov (dx2, -tic2)
60          x = x + dx2

         if (x.ge.xmax) goto 50
         call psrlin (0., tic1, rline, iwidth)
         call psrmov (dx2, -tic1)
         x = x + dx2

         do 70 i = 1, 4
            if (x.ge.xmax) goto 50
            call psrlin (0., tic2, rline, iwidth)
            call psrmov (dx2, -tic2)
70          x = x + dx2

         goto 40

50       if (x0-dx2.lt.xmin) goto 99

         x = x0 - dx2

         call psmove (x, y0)

         do 80 i = 1, 4
            if (x.le.xmin) goto 99
            call psrlin (0., tic2, rline, iwidth)
            call psrmov (-dx2, -tic2)
80          x = x - dx2

         if (x.le.xmin) goto 99
         call psrlin (0., tic1, rline, iwidth)
         call psrmov (dx2, -tic1) 
         x = x - dx2 

         do 90 i = 1, 4
            if (x.le.xmin) goto 99
            call psrlin (0., tic2, rline, iwidth)
            call psrmov (-dx2, -tic2)
90          x = x - dx2

      end if 

99    end
 
      subroutine psylbl (xmin, xmax, y0, ymax, dy, dcx, dcy, tmin, igrd)
 
c psylbl - subroutine to put on y-axis labels.

      implicit real (a-g,o-z),integer (h-n)
 
      character*12 numbs(40)
 
      integer ic(40)

      common / xyrat /xfac

      xdc = 1.4 * dcx
      ydc = .8 * dcy
      tmin = 1e30
 
      call psnum (y0,ymax,dy,ic,iy1,numbs)
 
      y = y0
 
      do 10 i = 1, iy1
 
         t = xmin - (float(ic(i)+1) * xdc) / xfac
         if (t.lt.tmin) tmin = t
         call pstext (t, y + ydc, numbs(i), ic(i))
         if (igrd.eq.1) call psline (xmin, y, xmax, y, 10., 0)
 
10    y = y + dy
 
      end
 
      subroutine psnum (rmin,rmax,dr,ic,i1,numbs)

      implicit real (a-g,o-z),integer (h-n)
 
      character*1 text(12), numbs(40)*12, next(12)
 
      integer ic(40), k

      i1 = 1 + ifix ((rmax - rmin) / dr)
 
      if (rmax.gt. 9999.9 .and.rmax.lt. 99999.9 .and.rmin.gt.-rmax) then
         icase = 1
      else if (rmax.gt. 999.9 .and.rmax.le. 9999.9
     *                        .and.rmin.gt.-rmax) then
         icase = 2
      else if (rmax.gt. 99.9 .and.rmax.le. 999.9
     *                       .and.rmin.gt.-rmax) then
         icase = 3
      else
         icase = 4
      end if
 
      r = rmin
 
      do 10 i = 1, i1
         goto (1,2,3,4) icase
1        write (numbs(i),1001) ifix(r)
         goto 20
2        write (numbs(i),1002) ifix(r)
         goto 20
3        write (numbs(i),1003) ifix(r)
         goto 20
4        write (numbs(i),1004) r
20       read (numbs(i),1010) text
         k = 0
         do 30 j = 1, 12
            if (text(j).eq.' ') goto 30
            k = k + 1
            next(k) = text(j)
30       continue
         ic(i) = k
         write (numbs(i),1010) (next(j),j=1,k)
10    r = r + dr
 
1001  format (i5)
1002  format (i4)
1003  format (i3)
1004  format (g9.3)
1010  format (12a1)
 
      end
 
      subroutine psxlbl (x0, dx, dc, dyl, igrd)
 
c psxlbl - subroutine to put on x-axis labels.

      implicit real (a-g,o-z),integer (h-n)
 
      character*12 numbs(40)

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
 
      integer ic(40)

      common / xyrat /xfac
c
      y = ymin - dyl
 
      x = x0
 
      xdc = .75 * dc
 
      call psnum (x0,xmax,dx,ic,ix1,numbs)
 
      do 10 i = 1, ix1
         if (x.eq.xmin.or.x.eq.xmax) goto 10
         t = x - (float(ic(i)) * xdc) / xfac
         call pstext (t, y, numbs(i), ic(i))
         if (igrd.eq.1) call psline (x, ymin, x, ymax, 10., 0)
10    x = x + dx
 
      end
c-----------------------------------------------------------------
      subroutine psalbl (x,y,ipr,ivar,ird,ityp,rline,iop9,fac1)
 
c psalbl - subroutine to output reaction(ityp=0) or ip(ityp=1)
c          name label.

      implicit real (a-g,o-z),integer (h-n)
 
      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ basic /n4,ifont,icopt,jwidth,iop0
 
      real x(ipr),y(ipr)
  
      character*6 lnms, pnms, string*400
 
      if (ivar.eq.1) then
            fac = 1.0 * fac1
      else
            fac = 0.75 * fac1
      end if
 
      if (ityp.eq.0) then
c                                       get curve midpoint
         dx = (x(ipr) - x(1))
         dy = (y(ipr) - y(1))
         delta = 1d30
 
         if (abs(dx)/xlen.gt.abs(dy)/ylen) then
            xmid = x(1) + dx / 2.
 
            do i = 2, ipr
               if (abs(x(i)-xmid).lt.delta) then
                  delta = abs(x(i)-xmid)
                  imid = i
               end if
            end do 
 
         else
            ymid = y(1) + dy / 2.
            do i = 2, ipr
               if (abs(y(i)-ymid).lt.delta) then
                  delta = abs(y(i)-ymid)
                  imid = i
               end if
            end do 
         end if
 
         if (iop9.eq.0) then
c                                   numeric label:
             write (lnms,1000) ird

             call pssctr (ifont,fac,fac,0.0)
             if (ird.lt.10) then
                call pselip (x(imid),y(imid),
     *                      fac*dcx,fac*1.2*dcy,rline,0,1)
                call pstext (x(imid)-2.45*dcx*fac,
     *                      y(imid)+0.8*dcy*fac,lnms,6)
             else if (ird.lt.100) then
                call pselip (x(imid),y(imid),fac*1.74*dcx,fac*1.6*dcy,
     *                      rline,0,1)
                call pstext (x(imid)-2.71*dcx*fac,
     *                      y(imid)+0.8*dcy*fac,lnms,6)
             else if (ird.lt.1000) then
                call pselip (x(imid),y(imid),
     *                       fac*2.75*dcx,fac*1.83*dcy,rline,0,1)
                call pstext (x(imid)-3.04*dcx*fac,
     *                       y(imid)+0.8*dcy*fac,lnms,6)
             else if (ird.lt.10000) then 
                call pselip (x(imid),y(imid),
     *                       fac*3.75*dcx,fac*2.*dcy,rline,0,1)
                call pstext (x(imid)-4.*dcx*fac,
     *                       y(imid)+0.8*dcy*fac,lnms,6)
             else 
                call pselip (x(imid),y(imid),
     *                       fac*4.75*dcx,fac*2.*dcy,rline,0,1)
                call pstext (x(imid)-4.*dcx*fac,
     *                       y(imid)+0.8*dcy*fac,lnms,6)
             end if
         else
            if (x(imid).eq.x(imid-1)) then
               theta = 1.5708
            else if (y(imid).eq.y(imid-1)) then
               theta = 0.0
            else 
c                                   text label, get angle:
               theta = atan ( ((y(imid)-y(imid-1)) / ylen)
     *                      / ((x(imid)-x(imid-1)) / xlen) )
            end if 
 
            call rxntxt (string,iend)
c                                   normalized x text length:
            clx = iend * dcx * fac  / xlen / 2.
c                                   normalized y text displacement:
            cly = .5 * dcy / ylen
c                                   get displacements from midpoint:
            dy = (sin(theta) * clx + cos(theta) * cly) * ylen
 
            dx = (cos(theta) * clx - sin(theta) * cly) * xlen
 
            theta = 57.29578 * theta
 
            call pssctr (ifont,fac,fac,theta)
            call pstext (x(imid)-dx,y(imid)-dy,string,iend)
 
         end if
      else
c                                  invariant point labels:
         if (ird.gt.999) then
            write (pnms,1040) ird
         else if (ird.gt.99) then 
            write (pnms,1010) ird
         else if (ird.gt.9) then
            write (pnms,1020) ird
         else
            write (pnms,1030) ird
         end if
 
         call pssctr (ifont,1.2*fac,1.2*fac,0.)
         call pstext (x(1)+.7*dcx,y(1)+.5*dcy,pnms,6)
 
      end if
 
1000  format (i5)
1010  format ('(',i3,') ')
1020  format ('(',i2,')  ')
1030  format ('(',i1,')   ')
1040  format ('(',i4,')')
 
      end

c---------------------------------------------------------------
      subroutine rname (iw,prompt)

      implicit real (a-g,o-z),integer (h-n)

      character*10 xnams, xnam, prompt*14

      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common/ excl4 /xnams(50,3)

      jxct = 1

110   write (*,1040) prompt
      read (*,1020) xnam

      if (xnam.eq.' ') goto 210

      call matchi (xnam,iex(jxct,iw),jex(jxct,iw))

      if (iex(jxct,iw).eq.-1) then
         write (*,1100) xnam
         goto 110
      end if

      xnams(jxct,iw) = xnam
      jxct = jxct + 1

      goto 110
 
210   ixct(iw) = jxct - 1

1020  format (a)
1040  format (/,' Enter the name of a phase ',a,' fields ',
     *        /,' (left justified, <cr> to finish): ')
1100  format (/,' No such entity as ',a,', try again: ')

      end 

c---------------------------------------------------------------
      subroutine pscurv (iop1,iop2,iop4,iop5,iop6,iop7,
     *                   iop8,lop,fac1,fac2,fac3,iend,ipoly)

c pscurv - subroutine to output curves.

      implicit real (a-g,o-z),integer (h-n)
 
      include 'perplex_parameters.h'

      parameter (l3=l2+2)

      integer  k, idr, lchk(k2), lop(15), jap(2), idv(k7), iaid(2)
 
      real x(l5), y(l5)
 
      character*10 names*8, xnams

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ rxn /vnu(k7),idr(k7),ivct,iplus(k7),iminus(k7)
      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common/ excl4 /xnams(50,3)/ phase /ikp(k1)/ cst8 /names(k1)
      common/ basic /n4,ifont,icopt,jwidth,iop0
     *      / cst74 /idbk(k5,k2),jvar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)
     */ cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     */ cst78 /vcpd(2,k2),icpd(k2),vpha(2,k3),ipha(k3),lex(k2)
     */ cst79 /prmn(k3),prmx(k3),rcps(k7),ibad(k2),icps(k7),kcx,lcx,jcx1
     */ cst80 /tmn(k3),tmx(k3)
     */ cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr


      data lchk/k2*0/

      iend = 0

      do i = 1, 3
         ict(i) = 0
      end do 

      do i = 1, k2
         icpd(i) = 0
         vcpd(1,i) = 0.
         vcpd(2,i) = 0.
      end do 

      do i = 1, k3
         lex(i) = 0
         ipha(i) = 0
         vpha(1,i) = 0.
         vpha(2,i) = 0.
         prmn(i) = 1e30
         prmx(i) = -1e30
      end do 

10    read (n4,*,end=100) ipt,ird,ivar,ivct,(idr(i),i=1,ivct),iaid,jap 
      read (n4,*) (vnu(i),i=1,ivct)
 
      if (ipt.eq.1) then
         goto 99
      else if (ipt.eq.0) then
         goto 10
      end if

      ipr = ipt/2

      if (ird.gt.k2) then
         write (*,1000) k2
         stop
      end if

      if (ipr.gt.l5*2) then
         write (*,*) ' increase l5 (pscurv) in perplex_parameters.h'
         stop
      end if
 
      read (n4,*) (x(i),y(i),i=1,ipr)
c                            variance restrictions:
      if (icopt.lt.5) then
c                            projections
         if (iop4.eq.1.and.ivar.gt.1) goto 10
c                            copy phase id's into idv
c                            array for phase restrictions:
            do i = 1, ivct 
               idv(i) = idr(i)
            end do 
            jvct = ivct 
      else 
c                            estimate centroid of cpd field and 
c                            true phase field:
         do j = 1, 2
            kap = iaid(j)
            lap = jap(j)
c                            copy phase id's into idv
c                            array for phase restrictions:
            if (j.eq.1) then 
               do i = 1, icp
                  idv(i) = idbk(i,kap)
               end do
            else 
               do 40 i = 1, icp
                  do k = 1, icp
                     if (idv(k).eq.idbk(i,kap)) goto 40
                  end do 
                  jvct = icp + 1
                  idv(jvct) = idbk(i,kap) 
                  goto 50 
40             continue 
            end if 
c                            get range of a property if requested
50          if (lop(13).eq.1.and.jap(j).ne.0) then 

               call getprp (vtemp(1,kap),vtemp(2,kap),
     *                      lop(14),kap,prop,kcx,lcx,jcx1,icps,rcps)
               if (prop.lt.prmn(lap)) prmn(lap) = prop
               if (prop.gt.prmx(lap)) prmx(lap) = prop     
            end if 
c
            if (ipoly.eq.2) then
c                            pseudosections without polygon output:
               vcpd(1,kap) = vcpd(1,kap) + x(1) + x(ipr)
               vcpd(2,kap) = vcpd(2,kap) + y(1) + y(ipr)
               icpd(kap) = icpd(kap) + 2
               if (lap.ne.0) then
                  vpha(1,lap) = vpha(1,lap) + x(1) + x(ipr)
                  vpha(2,lap) = vpha(2,lap) + y(1) + y(ipr)
                  ipha(lap) = ipha(lap) + 2
                  lex(lap) = kap
               end if 
            else 
c                            assume centroids available from polygon
               icpd(kap) = 1
               if (lap.ne.0) then 
                  if (abs(tmn(lap)-vtemp(1,kap)).lt.tmx(lap)) then
                     tmx(lap) = abs(tmn(lap)-vtemp(1,kap))
                     lex(lap) = kap
                  end if 
               end if 
            end if 
         end do 
c            
         if (jap(2).ne.0.and.lop(11).eq.1) then
            if (jap(1).eq.jap(2)) goto 10
         else if (lop(11).eq.2) then 
            goto 10 
         end if 
c
      end if 

      call checkr (iop5,iop6,iop7,idv,k7,jvct,imatch)
      if (imatch.eq.1) goto 10 
 
      if (iop1.eq.1) then
         jpr = 0
         do 20 i = 1, ipr
            if (x(i).gt.xmax.or.x(i).lt.xmin.or.
     *          y(i).gt.ymax.or.y(i).lt.ymin) goto 20
            jpr = jpr + 1
            x(jpr) = x(i)
            y(jpr) = y(i)
20       continue
         if (jpr.eq.0) goto 10
         ipr = jpr
      end if

      kvar = ivar 
 
      if (ivar.eq.1) then
         iwidth = 1
         if (lop(11).eq.1) iwidth = 2
      else if (ivar.eq.98) then
         ivar = 1
         iwidth = 2
      else if (ivar.eq.99) then
         ivar = 1
         iwidth = 0
      else
         iwidth = 0
         if (lop(11).eq.1) ivar = 1
      end if
 
      rline = float(ivar)
      iwidth = iwidth * jwidth
 
      if (iop8.eq.0) then
         call pspyln (x,y,ipr,rline,iwidth,0)
      else
         call psbspl (x,y,ipr,rline,iwidth,0)
      end if
 
      if (ird.eq.0) goto 10
 
      if (iop2.eq.0.and.lchk(ird).eq.0) then

         if (lop(15).eq.1.and.kvar.ne.1) goto 10 
 
         yfrac = abs(y(ipr)-y(1)) / ylen
         xfrac = abs(x(ipr)-x(1)) / xlen

         if (xfrac.lt.fac3.and.yfrac.lt.fac3) then
c                                     curve is too short
            goto 10
         else if (xfrac.lt.fac2.and.yfrac.lt.fac2) then
c                                     use a numeric label
            call psalbl (x,y,ipr,ivar,ird,0,1.,0,fac1)
         else
c                                     use a text label
            if (ivct.ne.0) call psalbl (x,y,ipr,ivar,ird,0,1.,1,fac1)
         end if

         lchk(ird) = 1
 
      end if
 
      goto 10

100   write (*,1010) 
      iend = 1
 
99    if (iop5.eq.1) write (6,*) ict(1),
     *               ' curves have the assemblage: ',
     *               (xnams(k,1),' ',k = 1, ixct(1))

      if (iop6.eq.1) write (6,*) ict(2),
     *               ' curves have none of the phases: ',
     *               (xnams(k,2),' ',k = 1, ixct(2))

      if (iop7.eq.1) write (6,*) ict(3),
     *               ' curves have one of the phases: ',
     *               (xnams(k,3),' ',k = 1, ixct(3))

1000  format ('Too many reactions, increase parameter k2 (',
     *       i4,') in routine pscurv',/)
1010  format ('End-of-file! if this is a VERTEX plot file then',
     *        ' VERTEX terminated incorrectly',/)
      end

c---------------------------------------------------------------
      subroutine plumin (ip,im)

c subprogram to order a reactants according to sign)

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      real vp(k7), vm(k7)

      common/ rxn /vnu(k7),idr(k7),ivct,iplus(k7),iminus(k7)

      ip = 0
      im = 0
c                             load id's of phases with + or - coeffs
      do 10 i = 1, ivct
         if (vnu(i).gt.0.0) then
            ip = ip + 1
            vp(ip) = vnu(i)
            iplus(ip) = idr(i)
         else
            im = im + 1
            vm(im) = vnu(i)
            iminus(im) = idr(i)
         end if
10    continue

      do 20 i = 1, im
         vnu(i) = vm(i)
20       idr(i) = iminus(i)

      do 30 i = 1, ip
         vnu(i+im) = vp(i)
30       idr(i+im) = iplus(i)

      end
c---------------------------------------------------------------
      subroutine rxntxt (string,iend)
 
c subprogram to write a text label for a reaction
 
      implicit real (a-g,o-z),integer (h-n)
 
      include 'perplex_parameters.h'
 
      character*8 names, text(400)*1, fname*10, string*400
  
      common/ csta7 /fname(h9)/ cst8 /names(k1)/ phase /ikp(k1)
      common/ rxn /vnu(k7),idr(k7),ivct,iplus(k7),iminus(k7)
 
c                             load id's of phases with + or - coeffs
      call plumin (ip,im)
c                             now dump the names into the array text
      ist = 1
      is = 1
80    do 20 i = is, im
         id = idr(i)
         if (ikp(id).eq.0) then
c                             simple compound:
            read (names(id),1000) (text(j), j = ist, ist + 7)
            text(ist+8) = ' '
            ist = ist + 9
         else
c                             solution phases:
            read (fname(ikp(id)),1000) (text(j), j = ist, ist + 9)
            text(ist+10) = '('
            read (names(id),1000) (text(j), j = ist + 11, ist + 18)
            text(ist+19) = ')'
            text(ist+20) = ' '
            ist = ist + 21
         end if
20    continue
 
      if (is.eq.1) then
         text(ist) = '='
         text(ist+1) = ' '
         ist = ist + 2
         is = im + 1
         im = ivct
         goto 80
      else
         text(ist) = ' '
      end if
c                             now filter out blanks
      iend = 1
      do 40 i = 2, ist
         if (text(i).eq.' '.and.text(i+1).eq.' ') then
            goto 40
         else if (text(i).eq.' '.and.text(i+1).eq.')') then
            goto 40
         else if (text(i).eq.' '.and.text(i+1).eq.'(') then
            goto 40
         end if
      iend = iend + 1
      text(iend) = text(i)
40    continue
 
      if (iend.gt.400) iend = 400
      write (string,1000) (text(i),i=1,400)
 
1000  format (400a1)
 
      end
c---------------------------------------------------------------
      subroutine psipts (iop1,iop3,iop4,iop5,iop6,iop7,fac1)
 
c psipts - subprogram to output invariant points.

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      parameter (k8=k5+2)
 
      character*10 xnams

      real x(1), y(1)
 
      integer ipds(k8), k
  
      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common/ basic /n4,ifont,icopt,jwidth,iop0/ excl4 /xnams(50,3)
      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen

      data iop9/0/

      do 11 i = 1, 3
11       ict(i) = 0
 
      read (n4,*) ipct, incts
 
      if (ipct.eq.0) goto 99
 
      do 20 i = 1, ipct
 
         read (n4,*) ipid,ipvar,(ipds(j), j=1,incts),x,y

         if (iop4.eq.1.and.ipvar.ne.1) goto 20 
 
         if (iop1.eq.1) then
            if (x(1).gt.xmax.or.x(1).lt.xmin.or.
     *          y(1).gt.ymax.or.y(1).lt.ymin) goto 20
          end if
 
         call checkr (iop5,iop6,iop7,ipds,k8,incts,imatch)
         if (imatch.eq.1) goto 20
 
         if (ipvar.eq.1) then
            r = .78
         else
            r = .39
         end if
 
         rline = ipvar
 
         call pselip (x(1),y(1),r*dcx,r*dcy,0.,0,7)
 
         if (iop3.eq.0) call psalbl (x,y,1,ipvar,ipid,1,
     *                               rline,iop9,fac1)
 
20    continue
 
      if (iop5.eq.1) write (6,*) ict(1),
     *               ' points have the assemblage: ',
     *               (xnams(k,1),' ',k = 1, ixct(1))

      if (iop6.eq.1) write (6,*) ict(2),
     *               ' points do not have any of the phases: ',
     *               (xnams(k,2),' ',k = 1, ixct(2))

      if (iop7.eq.1) write (6,*) ict(3),
     *               ' points have one of the phases: ',
     *               (xnams(k,3),' ',k = 1, ixct(3))
 
99    end
 

 
      subroutine checki (iw,iun,itis)
c----------------------------------------------------------------
 
c checki - subroutine to determine if the cpd iun is in the
c          list iex or jex solution or compound name.
 
c   itis = -1 if not, itis>=0 if it is.
 
      implicit real (a-g,o-z),integer (h-n)
 
      include 'perplex_parameters.h'
 
      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common/ phase /ikp(k1)
 
      if (ikp(iun).ne.0) then
         id = ikp(iun)
         do 10 i = 1, ixct(iw)
            if (id.eq.iex(i,iw)) then
               itis = iex(i,iw)
               goto 99
             end if
10       continue
      end if
 
      do 20 i = 1, ixct(iw)
         if (iun.eq.jex(i,iw)) then
            itis = 0
            goto 99
         end if
20    continue
 
      itis = -1
99    end

c-------------------------------------------------------------------------
      subroutine psmixd 

      implicit real (a-g,o-z),integer (h-n)
 
c psmixd - subroutine to draw binary mixed variable diagrams

      include 'perplex_parameters.h'
  
      character*8 names, vname, title*162, sname*10, string*400, y*1
      character*8 tname(5),xname(k5)
  
      integer idss(10), idf(3), jphi(k1)

      real v(l2)

      parameter (l3=l2+2)

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
      common/ rxn /vnu(k7),idr(k7),ivct,iplus(k7),iminus(k7)
      common/ cst8 /names(k1)/ csta7 /sname(h9)/ phase /ikp(k1)
      common/ tx /x(k1),iphi(k1),ivph(k1),iphct,ib,istct
      common / wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ basic /n4,ifont,icopt,jwidth,iop0 / xyrat /xfac

      data idf,igo/4*0/
c                                  start-of-header
c                                  ------------------------------
c                                  read simple variables
      read (n4,*) icp,istct,iphct,ipoint,ifyn,isyn,ipot,isoct

      if (icp.ne.2) then 
         write (*,*) 'Sorry, PSVDRAW only works',
     *               ' for binary mixed variable diagrams.'
         goto 99
      end if 
 
      if (iv.gt.5.or.ib.gt.k1.or.ipot.gt.5) then
         write (*,*) 'dimensioning error in psmixd '
         goto 99
      end if

      if (isoct.ne.0) write (*,1060)
 
      read (n4,1000) (tname(i), i = 1, ipot)
      read (n4,1000) title
c                                  names
      read (n4,1020) (names(i),i=1,iphct)
c                                  phase coordinates
      read (n4,*) (x(i), i = istct, iphct)
c                                  read solution identifier flags
      read (n4,*) (ikp(i),i=1,iphct)
c                                  read solution names
      if (isoct.ne.0) read (n4,1050) (sname(i), i=1, isoct)

      read (n4,1020) (xname(i),i = 1, icp)
c                                  end-of-header
c                                  ------------------------------
      read (n4,*) (v(i), i = 1, ipot)
c                                  read stable phase ids
      read (n4,*) ib
      read (n4,*) (iphi(i), i = 1, ib)
c                                  read saturated phase id's
      goto (10),isyn
 
      read (n4,*) isat
      read (n4,*) (idss(i),i=1,isat)
c                                  read index of y variable
10    read (tname(1),1020) vname(2)
      vname(1) = xname(2)

      read (n4,*) vmin(2), vmax(2) 

      vmin(1) = 0.0
      vmax(1) = 1.0

      call psaxop (jop0,iop1,iop8,fac)
c                              get some other options
      iop1 = 1
      iop2 = 0
      iop3 = 0

      fac = 1.
      rx = dcx/4./xfac
      ry = dcy/4.

      if  (iop0.eq.1) then 
         write (*,2050)
         read (*,1000) y
         if (y.eq.'y'.or.y.eq.'Y') iop2 = 1

         write (*,2030)
         read (*,1000) y
         if (y.eq.'y'.or.y.eq.'Y') then
            iop1 = 0
         else 
            write (*,2040)
            read (*,1000) y
            if (y.eq.'y'.or.y.eq.'Y') iop1 = 2
         end if 
         if (isoct.gt.0) then
            write (*,2060)
            read (*,1000) y
            if (y.eq.'y'.or.y.eq.'Y') iop3 = 1
         end if 
      end if 

      t0 = vmin(2)
      tlast = t0 - t0     
c                              get the variance of each compound:
      do i = 1, ib
         call getvar (i,iop3)
      end do 

130   read (n4,*) ird, ivct, ivar, t1, (idr(i), i = 1, ivct),
     *                                 (vnu(i), i = 1, ivct)

      if (ivct.eq.1) goto 90

      do i = 1, ib 
         jphi(i) = iphi(i)
      end do 

      jb = ib 

      call plumin (jplus,jminus)

      do i = 2, ib - 1
         rline = ivph(i)
         if (rline.ne.0.0) call psline 
     *                     (x(iphi(i)),t0,x(iphi(i)),t1,rline,0)
      end do 

         isum = 0
         idif = 0

         do 50 i = 1, ivct
            if (ikp(idr(i)).ne.0) then
               isum = isum + 1
               do j = 1, idif
                  if (idf(j).eq.ikp(idr(i))) goto 50
               end do 
               idif = idif + 1
               idf(idif) = ikp(idr(i))
            end if 
50       continue 
c                              consider different cases:
      if (ivct.eq.2) then
c                              get index (id) of reacted phase:
         do i = 1, ib
            if (iphi(i).eq.idr(1)) then
               i1 = i - 1 
               if (i1.lt.1) i1 = 1
               id1 = iphi(i1)
               it = i
               i2 = i + 1
               if (i2.gt.ib) i2 = ib 
               id2 = iphi(i2)   
               goto 55
            end if
         end do 

         write (*,*) 'nope'
         write (*,*) (iphi(i),i=1,ib)
         write (*,*) idr(1), ird,t1
         goto 99
c                              check if only a compositional
c                              change in a solution:
55       if (isum.eq.2.and.ikp(idr(1)).eq.ikp(idr(2))) then
c                              draw an open dot, but don't
c                              do anything else:         
            call pselip (x(idr(1)),t1,rx,ry,1.,0,0)
            iphi(it) = idr(2)          
            goto 130
         end if  
c                              draw dot         
         call pselip (x(idr(1)),t1,rx,ry,1.,0,7)
c                              draw line
         call psline (x(id1),t1,x(id2),t1,1.,0)
c                              replace reacted phase:
         iphi(it) = idr(2)
         call getvar (it,iop3)
         if (it.gt.1) call getvar (it-1,iop3)
         if (it.lt.ib) call getvar (it+1,iop3)

      else  
c                              classify reaction, jminus = 2 
c                              eutectoid, else peritectoid.
         if (jminus.eq.2) then
 
            i1 = idr(1)
            i2 = idr(2)
            i0 = idr(3)
c                              find indices of old phases:
            it = 0
            do i = 1, ib
               if (iphi(i).eq.i1) id1 = i
               if (iphi(i).eq.i2) id2 = i 
            end do 
               
         else 

            i0 = idr(1)
            i1 = idr(2)
            i2 = idr(3)
c                              find indices of old phases:
            do i = 1, ib
               if (iphi(i).eq.i1) id1 = i
               if (iphi(i).eq.i2) id2 = i
            end do 

         end if 

         if (id1.gt.id2) then
            it = id1
            jt = i1
            i1 = i2
            i2 = jt
            id1 = id2
            id2 = it
            if (jminus.eq.2) then
               idr(1) = i1
               idr(2) = i2
            else 
               idr(2) = i1
               idr(3) = i2
            end if
         end if

         if (isum.lt.2.or.idif.eq.3) then 
c                              all phases different
c                              draw line
            call psline (x(i1),t1,x(i2),t1,1.,0)
            call pselip (x(i0),t1,rx,ry,1.,0,7)

         else if (isum.eq.2) then
            if (idif.eq.2) then 
c                              all phases different
               call psline (x(i1),t1,x(i2),t1,1.,0)
               call pselip (x(i0),t1,rx,ry,1.,0,7)

            else 
c                              one solution + one compound
               if (ikp(i0).eq.0) then
c                              compound in the middle
c                              change variance of reaction
                  ivar = 1

                  call pselip (x(i0),t1,rx,ry,1.,0,7)

                  call psline (x(i1), t1, x(i2), t1, 1., 0)          

               else 
c                              pseudoinvariant
                  if (ikp(i0).eq.0) then
                     call psline (x(i1),t1,x(i2),t1,1.,0)
                  else if (ikp(i1).eq.0) then
                     call psline (x(i0),t1,x(i2),t1,1.,0)
                  else 
                     call psline (x(i0),t1,x(i1),t1,1.,0)
                  end if 
               end if
            end if

         else if (isum.eq.3.and.idif.eq.1.and.igo.eq.0) then
c                              reaction on solvus
c                              check if on left line
            itot = 0
            call miscib (x(i1),x(i0),ikp(i0),imis,igo)
            if (imis.eq.0) call psline (x(i0),t1,x(i1),t1,1.,0)
            itot = itot + imis
            call miscib (x(i0),x(i2),ikp(i0),imis,igo)
            itot = itot + imis
            if (imis.eq.0) call psline (x(i0),t1,x(i2),t1,1.,0)
            if (itot.eq.0) then
               ivar = 1
               call pselip (x(i0),t1,rx,ry,1.,0,7)
            end if 


         else 
c                              two solutions present.
c                              solvus possible, find
c                              the pseudocompounds of
c                              the same solution:
            if (ikp(i0).ne.ikp(i1).and.ikp(i0).ne.ikp(i2)) then
c                              i1 and i2 are the same:
               call miscib (x(i1),x(i2),ikp(i1),imis,igo)
            else if (ikp(i0).eq.ikp(i1)) then
c                              i0 and i1 are the same:
               call miscib (x(i1),x(i0),ikp(i0),imis,igo)
            else 
c                              i0 and i2 are the same:
               call miscib (x(i0),x(i2),ikp(i0),imis,igo)
            end if 

            if (imis.eq.1) then
                  ivar = 1
c                              eutectic/peritectic with solvus
                  call psline (x(i1),t1,x(i2),t1,1.,0)
                  call pselip (x(i0),t1,rx,ry,1.,0,7)
            else if (ikp(i1).eq.ikp(i0)) then
c                              pseudounivariant, left
               call psline (x(i1),t1,x(i0),t1,1.,0)

            else if (ikp(i2).eq.ikp(i0)) then
c                              pseudounivariant, right
               call psline (x(i2),t1,x(i0),t1,1.,0)

            else
c                              else center
c                              compound in the middle
c                              change variance:
               itoc = 1
               do 210 j = 1, ib
                  if (iphi(j).eq.i0) goto 210
                  if (ikp(iphi(j)).eq.ikp(i0)) itoc = 0
210            continue 

               if (itoc.eq.1) ivar = 1

               if (ivar.eq.1) call pselip 
     *                        (x(idr(1)),t1,rx,ry,1.,0,7)

               call psline ( x(iphi(id1)), t1,
     *                       x(iphi(id2)), t1, 1., 0)

            end if 
         end if 
c                              get new chemography:
         if (jminus.eq.2) then
c                              eutectoid, number of phases
c                              increases.
            do i = ib, id2, -1
               iphi(i+1) = iphi(i)
               ivph(i+1) = ivph(i)
            end do 
            ib = ib + 1
            iphi(id1+1) = i0
            do i = id1, id1 + 2
               call getvar (i,iop3)
            end do 
         else
c                              peritectoid, number of phases
c                              decreases.
            do i = id2, ib
               iphi(i-1) = iphi(i)
               ivph(i-1) = ivph(i)
            end do 
            ib = ib - 1
            do i = id1, id1 + 1
               call getvar (i,iop3)
            end do 
         end if            
      end if

      if (iop2.eq.1) then 
         do 170 i = 1, ib - 1
            if (ikp(iphi(i)).eq.0) goto 170
            i1 = i + 1
            if (ikp(iphi(i)).ne.ikp(iphi(i1))) goto 170
            do j = 1, jb - 1
               if (x(jphi(j)).gt.x(iphi(i))) then
                  goto 170
               else if (x(jphi(j)).eq.x(iphi(i))) then
                  j1 = j + 1
                  if (ikp(jphi(j)).eq.ikp(iphi(i)).and.
     *                ikp(jphi(j)).eq.ikp(jphi(j1))) then
c                                  draw a rectangle from
c                                  i-i1-j-j1
                      call psrect (x(iphi(i)),x(iphi(i1)),
     *                             t0,t1,0.,iwidth,2)
                  end if
               end if
            end do 
170      continue
      end if 

      t0 = t1 

      if (iop1.eq.0) then 
         goto 130
      else if (iop1.eq.1) then
         if (ivar.ne.1) goto 130 
         call rxntxt (string,iend)
      else 
         call rxntxt (string,iend)
      end if 

      call pssctr (7,fac,fac,0.)
      ttext = t1 + .9 * dcy 
      if (ttext.lt.tlast+2.1*dcy) ttext = tlast + 2.1*dcy
      call pstext (xmax+2.*dcx,ttext,string,iend)
      tlast = ttext

      goto 130         

90    t1 = vmax(2)
c                                   fill in last part of one phase regions
      if (iop2.eq.1) then 
         do 180 i = 1, ib - 1
            if (ikp(iphi(i)).eq.0) goto 180
            i1 = i + 1
            if (ikp(iphi(i)).ne.ikp(iphi(i1))) goto 180
c                                  draw a rectangle from
c                                  i-i1-j-j1
                      call psrect (x(iphi(i)),x(iphi(i1)),
     *                             t0,t1,0.,iwidth,2)
180      continue
      end if 

      do 150 i = 2, ib - 1
         rline = ivph(i)
         if (rline.eq.0.0) goto 150
         call psline (x(iphi(i)),t0,x(iphi(i)),t1,rline,0)
150      continue

99    call psaxes (jop0)

1000  format (a)
1020  format (10a8)
1050  format (8a10)
1060  format (/,'WARNING: Psvdraw may not draw t-x diagrams',
     *          ' correctly if immiscibility',/,'occurs in a',
     *          ' projected ternary or higher order solution, to',
     *          ' avoid',/,'problems turn the miscibility test',
     *          ' off (modify default options).',/)
2030  format (/,'Suppress reaction labels (y/n)?')
2040  format (/,'Show pseudounivariant reaction labels (y/n)')
2050  format (/,'Try to fill one phase fields (y/n)?')
2060  format (/,'Skip tests for immiscibility (y/n)?')
 
      end
c-------------------------------------------------------------------
      subroutine getvar (i,igo)
 
c getvar - subroutine to get variance of compound i in a binary row

c     ivphi set 1 if true compound
c     ivphi set 0 if pseudocompound
c     ivphi set 2 if solvus limb and igo = 0.
c     if igo = 1 skip miscibility test

      implicit real (a-g,o-z),integer (h-n)
  
      include 'perplex_parameters.h'
  
      common/ phase /ikp(k1)/tx/x(k1),iphi(k1),ivph(k1),iphct,ib,istct

      if (i.eq.1.or.i.eq.ib) then 
         ivph(i) = 1
         goto 30
      end if 

         i1 = i - 1
         i2 = i + 1

         id1 = iphi(i1)        
         id = iphi(i)
         id2 = iphi(i2)

         if (ikp(id).eq.0) then 
c                              true compound
            ivph(i) = 1

         else if (ikp(id1).eq.ikp(id).and.ikp(id2).eq.ikp(id)) then
c                              only one solution:
            ivph(i) = 0
            call miscib (x(id1), x(id), ikp(id), imis, igo)
            if (imis.eq.1) ivph(i) = 1
            call miscib (x(id), x(id2), ikp(id), imis, igo)
            if (imis.eq.1) ivph(i) = 1
           
         else 

            ivph(i) = 1

         end if 

30    end 
c-------------------------------------------------------------------
      subroutine miscib (x1, x2, ids, imis, igo)

c miscib - subroutine check for immiscibility in a binary phase

c imis = 1 => solvus between solution(ids) compositions x1 and x2

      implicit real (a-g,o-z),integer (h-n)
  
      include 'perplex_parameters.h'
  
      character*8 names

      common/ cst8 /names(k1) 
      common/ phase /ikp(k1)
      common/ tx /x(k1),iphi(k1),ivph(k1),iphct,ib,istct

      imis = 0
c                                disabled cause of projections
      goto (99), igo

      do 10 i = istct, iphct
         if (ikp(i).ne.ids) goto 10
         if (x(i).gt.x1.and.x(i).lt.x2) then 
            imis = 1
            goto 99
         end if 
10    continue
99    end 

      subroutine psdplt (fname,jop0)
c----------------------------------------------------------------
c psdplt - subroutine to plot bulk compositions

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      parameter (l3=l2+2)

      integer lop(15)
 
      character*162 tname, yes*1, prompt*14, fname*100

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
     *     / excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
     *     / basic /n4,ifont,icopt,jwidth,iop0/ cst310 /tname(4)
     *     / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     */ cst79 /prmn(k3),prmx(k3),rcps(k7),ibad(k2),icps(k7),kcx,lcx,jcx1
c---------------------------------------------------------------
      iop2 = 0
      iop3 = 0
      iop5 = 0
      iop6 = 0
      iop7 = 0
      iop4c = 0 
      iop4p = 0 
 
      fac2 = .2
      fac3 = .05
c                                 icopt = 1 projection 
c                                 icopt = 6 polygonalized pseudosection
c                                 icopt = 5 gridded pseudosection

c                                 iop2 = 1 suppress curve labels
c                                 iop3 = 1 suppress point labels
      if (icopt.lt.5) then 
c                                 pseudosection, no curve/point labels
         iop2 = 0
         iop3 = 0
c                                 
      else 
         iop2 = 1
         iop3 = 1 
      end if 

      do i = 1, 15
c                                 lop(6) = 0 show divariant phase names 
         lop(i) = 0
      end do 
c                                 lop(11) = 2 draw no phase field boundaries
c                                 lop(11) = 1 draw only true phase fields
c                                 lop(11) = 0 draw all boundaries and points
c                                 lop(11) =-1 draw all boundaries, no points
c                                 lop(10) = 0 divariant field data available
      if (icopt.eq.1) then 
         lop(10) = 1
      else 
         lop(11) = 1
      end if 
c                                 label only true phase fields
      lop(12) = 1
c                                 divariant field label flags                                
      do i = 1, 5
c                                 lop(1) = 1 suppress number
c                                 lop(2) = 1 suppress variance
c                                 lop(3) = 1 suppress density
c                                 lop(4) = 1 suppress volatile content
c                                 lop(5) = 1 suppress modes
c                                 lop(6) = 1 suppress names                           
         lop(i) = 1
      end do 
c                                 lop(7) = 1 use solution names
      lop(7) = 1
c                                 get some options and
c                                 set up transformations
      call psaxop (jop0,iop1,iop8,fac1)

      if (iop0.eq.0) goto 30
c                                 phase field restrictions by variance 
      if (icopt.eq.5) goto 40

      write (*,1160)   

      if (icopt.eq.6) then 
         write (*,1250)
      else 
         write (*,1210)
      end if 
        
      read (*,1000) yes
      if (yes.eq.'y'.or.yes.eq.'Y') then
c                               variance restrictions
         if (icopt.lt.5) then
c                               for projections:
            write (*,1170) 
            read (*,1000) yes 
c                               pseudounivariant curves
            if (yes.eq.'y'.or.yes.eq.'Y') iop4c = 1

            write (*,1180) 
            read (*,1000) yes 
c                               pseudoinvariant points
            if (yes.eq.'y'.or.yes.eq.'Y') iop4p = 1
         else if (icopt.eq.6) then 
c                               restrictions for polygonalized pseudosections:
            write (*,1035) 
            read (*,1000) yes 
            if (yes.eq.'y'.or.yes.eq.'Y') then
               lop(11) = 2
               goto 40 
            else  
               write (*,1050) 
               read (*,1000) yes 
               if (yes.eq.'y'.or.yes.eq.'Y') then
                  lop(11) = 0
               else 
                  write (*,1040) 
                  read (*,1000) yes
c                               fix me!
                  if (yes.eq.'y'.or.yes.eq.'Y') lop(11) = -1
               end if 
            end if 
c                               pseudodivariant fields
c            write (*,1280)
c            read (*,1000) yes
c            if (yes.eq.'y'.or.yes.eq.'Y') then
c               write (*,1300)
c               read (*,*) ivmn, ivmx
c            end if 
         end if 
      end if  
c                               restrict by assemblage
40    write (*,1150) 
      read (*,1000) yes

      if (yes.eq.'y'.or.yes.eq.'Y') then
c                               if icp < jbulk write warning:
         if (icp.lt.jbulk) write (*,1400) 
         write (*,1140) 
         read (*,1000) yes
         if (yes.eq.'y'.or.yes.eq.'Y') then
            iop5 = 1
            prompt='present in the'
            call rname (1,prompt)
         end if
c                               restrict by phase presence
         write (*,1120)  
         read (*,1000) yes
         if (yes.eq.'y'.or.yes.eq.'Y') then 
            iop6 = 1
            prompt=' absent in all'
            call rname (2,prompt)
         end if 
c                               restrict by phase absence
         write (*,1130)
         read (*,1000) yes
         if (yes.eq.'y'.or.yes.eq.'Y') then 
            iop7 = 1
            prompt='present in all'
            call rname (3,prompt)
         end if 
      end if
c                                       equilibrium labeling
c                                       suppress/modify labels  
      write (*,1225)
      if (icopt.lt.3) then
         write (*,1230)
      else if (icopt.gt.5) then 
c                                       polygonal pseudosection
         write (*,1240) 
      else 
c                                       gridded section
         write (*,1245)
      end if
c                                       modify eq labeling
      read (*,1000) yes

      if (yes.eq.'y'.or.yes.eq.'Y') then 

         if (icopt.ne.5) then 

            if (icopt.eq.1) then 
c                                       suppress curve labels?
               write (*,1220) 
            else  
               write (*,1215) 
            end if 
            read (*,1000) yes
            if (yes.eq.'y'.or.yes.eq.'Y') iop2 = iabs(iop2-1)
 
            if (iop2.eq.0) then
c                                       curve label modifications
               write (*,1070)
               read (*,1000) yes
 
               if (yes.eq.'y'.or.yes.eq.'Y') then
                  write (*,1080)
                  read (*,1000) yes
                  if (yes.eq.'y'.or.yes.eq.'Y') lop(15) = 1 

10                write (*,1030)
                  read (*,*) fac2
                  if (fac2.lt.0.0.or.fac2.gt.1.0) then
                     write (*,1200) fac2
                     goto 10
                  end if
20                write (*,1110) fac2
                  read (*,*) fac3
                  if (fac3.lt.0.0.or.fac3.gt.fac2) then
                     write (*,1200) fac3
                     goto 20
                  end if
               end if
            end if 
c                                      suppress ip point labels
            if (icopt.eq.1) then 
               write (*,1190)
            else
               write (*,1195)
            end if 
            read (*,1000) yes
            if (yes.eq.'y'.or.yes.eq.'Y') iop3 = iabs(iop3-1)

         end if 
c                                      high variance fields labels
         if (icopt.gt.3) then 
c                                      label only true phase fields
            write (*,1270) 
            read (*,1000) yes

            if (yes.ne.'y'.and.yes.ne.'Y') then 
c                                      ask to indicate range of property
               write (*,1390)
               read (*,1000) yes
               if (yes.eq.'y'.or.yes.eq.'Y') then 
                  lop(13) = 1
                  call chsprp (lop(14),kcx,lcx,jcx1,icps,rcps)
                  write (*,1370) 
                  read (*,1000) yes
                  if (yes.eq.'y'.or.yes.eq.'Y') lop(6) = 1
               end if 
            else   
c                                      suppress divariant fields: 
               write (*,1290) 
               read (*,1000) yes
               if (yes.eq.'y'.or.yes.eq.'Y') then 

                  lop(10) = 1

               else
c                                      modify labeling?
                  write (*,1310)
                  read (*,1000) yes
                  if (yes.eq.'y'.or.yes.eq.'Y') then
                     write (*,1320) 
                     read (*,1000) yes
                     if (yes.eq.'y'.or.yes.eq.'Y') lop(1) = 0
                     write (*,1330) 
                     read (*,1000) yes
                     if (yes.eq.'y'.or.yes.eq.'Y') lop(2) = 0
                     write (*,1340) 
                     read (*,1000) yes
                     if (yes.eq.'y'.or.yes.eq.'Y') lop(3) = 0
                     write (*,1350) 
                     read (*,1000) yes
                     if (yes.eq.'y'.or.yes.eq.'Y') lop(4) = 0
                     write (*,1360) 
                     read (*,1000) yes
                     if (yes.eq.'y'.or.yes.eq.'Y') lop(5) = 0
                     write (*,1370) 
                     read (*,1000) yes
                     if (yes.eq.'y'.or.yes.eq.'Y') lop(6) = 1

                     if (lop(5).eq.0) then 
                        lop(7) = 0
                     else if (lop(6).eq.0) then
                        write (*,1380)
                        read (*,1000) yes
                        if (yes.eq.'y'.or.yes.eq.'Y') lop(7) = 0
                     end if 
                  end if 
               end if
            end if   
         end if        
      end if 
 
30    call pssctr (8,1.2,1.2,0.)
c                                 draw divariant fields if poly pseudosection:
      if (icopt.eq.6) 
     *   call pspoly (fname,iop1,iop5,iop6,iop7,lop,ipoly)
      if (icopt.ne.5) then 
c                                 draw univariant curves
         call pscurv (iop1,iop2,iop4c,iop5,iop6,iop7,
     *                iop8,lop,fac1,fac2,fac3,iend,ipoly)

         if (iend.eq.0.and.lop(11).eq.0) then 
            call psipts (iop1,iop3,iop4p,iop5,iop6,iop7,fac1)
         end if 
c                                 draw divariant field labels
         if (lop(10).eq.0) 
     *      call psclbl (iop1,iop5,iop6,iop7,lop,ipoly,fac1)
      else 
c                                 gridded pseudosection construction
         call psgrid (iop5,iop6,iop7,lop,fac1)

      end if 
 
      call pssctr (8,1.6,1.6,0.)

      x = xmin - .15 * xlen

      call pstext (x, ymax+.32*ylen, tname(1), 0)
      call pssctr (8,1.,1.,0.)

      y = ymax + 0.27 * ylen

      do i = 2, 4
         call pstext (x,y,tname(i),0)
         y = y - 0.03 * ylen
      end do 
 
1000  format (a)
1030  format (/,'Enter minimum fraction of the axes length that a',/
     *        ' curve must be to receive a text label (0-1): ')
1035  format (/,'Suppress all phase boundaries (y/n)? ')
1040  format (/,'Show all curves, suppress points (y/n)? ')
1050  format (/,'Show all curves and points (y/n)? ')
1060  format ('   ',a)
1070  format (/,'Change default labeling of curve segments (y/n)?')
1080  format (/,'Suppress labels of pseudounivariant curves (y/n)?')
1110  format (/,'Enter minimum fraction of the axes length that a',/
     *        'curve must be to receive a numeric label (0-',f5.3,'):')
1120  format (/,'Show only without phases (y/n)? ')
1130  format (/,'Show only with phases (y/n)? ')
1140  format (/,'Show only with assemblage (y/n)? ')
1150  format (/,'Restrict phase fields by phase identities (y/n)?',/,
     *        '  answer yes to:',/,
     *        '   - show fields that contain a specific assemblage',/,
     *        '   - show fields that do not contain specified phases',/,
     *        '   - show fields that contain any of a set of specified',
     *            ' phases ')
1160  format (/,'Restrict phase fields by variance (y/n)?'/,
     *          '  answer yes to:')
1170  format (/,'Suppress pseudounivariant curves (y/n)? ')
1180  format (/,'Suppress pseudoinvariant points (y/n)? ')
1190  format (/,'Suppress point labels (y/n)? ')
1195  format (/,'Show point labels (y/n)? ')
1200  format (/,g13.6,' is an invalid value.',/)
1210  format ('   - suppress pseudounivariant curves and/or',
     *        ' pseudoinvariant points ',/)
1215  format (/,'Show curve labels (y/n)? ')
1220  format (/,'Suppress curve labels (y/n)? ')
1225  format (/,'Modify default equilibrium labeling (y/n)?',/,
     *       '  answer yes to:')
1230  format ('   - modify/suppress [pseudo-] univariant curve labels',/
     *       ,'   - suppress [pseudo-] invariant point labels')
1240  format ('   - show [pseudo-] univariant curve labels',/,
     *        '   - show [pseudo-] invariant point labels',/,
     *        '   - modify/suppress [pseudo-] high variance field',
     *        ' labels')
1245  format ('   - modify/suppress [pseudo-] high variance field',
     *        ' labels')
1250  format ('   - show curves and points that do not correspond to',
     *        ' true phase boundaries',/,
     *        '   - suppress all phase boundaries')
1270  format (/,'Label all high variance phase fields (y/n)?')
1280  format (/,'Restrict pseudodivariant fields by true variance',
     *          ' (y/n)? ')
1290  format (/,'Suppress all high variance field labels (y/n)? ')
1300  format (/,'Enter minimum (2) and maximum (c+2) variance : ')
1310  format (/,'Modify high variance field labels (y/n)? ')
1320  format (/,'Add numerical label (y/n)? ')
1330  format (/,'Add variance label (y/n)? ')
1340  format (/,'Add density (y/n)? ')
1350  format (/,'Add volatile concentrations (y/n)? ')
1360  format (/,'Add modes (y/n)? ')
1370  format (/,'Suppress phase names (y/n)? ')
1380  format (/,'Use pseudocompound names (y/n)? ')
1390  format (/,'Indicate the range of a property in labels (y/n)? ')
1400  format (/,'WARNING: You can not specify saturated phases or',
     *          ' phases determined by',/,'component saturation',
     *          ' constraints in these restrictions.',/)       

      end 

c---------------------------------------------------------------
      subroutine psclbl (iop1,iop5,iop6,iop7,lop,ipoly,fac1)
 
c psclbl - subprogram to output bulk composition label data.

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      parameter (l3=l2+2)

      character*10 xnams, text*400
 
      integer k, lop(15), itag(k2)
  
      common/ rxn /vnu(k7),idr(k7),ivct,iplus(k7),iminus(k7)
     *     / excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
     *     / basic /n4,ifont,icopt,jwidth,iop0/ excl4 /xnams(50,3)
     *     / wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
     *     / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *              iflug(k5,k2)
     *     / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *     / cst78 /vcpd(2,k2),icpd(k2),vpha(2,k3),ipha(k3),lex(k2)
     *     / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     */ cst79 /prmn(k3),prmx(k3),rcps(k7),ibad(k2),icps(k7),kcx,lcx,jcx1

      do i = 1, 3
         ict(i) = 0
      end do 
c                                tag assemblages to be labeled
c                                if only true field are to be done:
      if (lop(12).eq.1) then 
         do i = 1, k2
            itag(i) = 0
         end do 

         do i = 1, k3
            if (lex(i).ne.0) itag(lex(i)) = 1
         end do 
      end if             
c                                for each assemblage:
      do 20 i = 1, ibulk

         do j = 1, jbulk
            idr(j) = idbk(j,i)
         end do 
c                                variance restriction
c         if (ivar(i).gt.ivmx.or.ivar(i).lt.ivmn) goto 20

         if (icpd(i).eq.0) then
            ibad(i) = 2
            xx = vtemp(1,i)
            yy = vtemp(2,i)
            write (*,*) 'assemblage ',i,' not found?',xx,yy
         else if (ipoly.eq.2) then
            xx = vcpd(1,i)/icpd(i)
            yy = vcpd(2,i)/icpd(i)
         else 
            xx = vtemp(1,i)
            yy = vtemp(2,i)
         end if 

c         if (ibad(i).ne.1) goto 30

         if (lop(12).eq.1) then
            if (iap(i).ne.0.and.itag(i).eq.1) then
c                                only labeling true field once
               if (ipoly.eq.2) then 
                  xx =  vpha(1,iap(i))/ipha(iap(i))
                  yy =  vpha(2,iap(i))/ipha(iap(i))
               else 
                  xx = vtemp(1,i)
                  yy = vtemp(2,i)
               end if 
            else if (iap(i).ne.0) then
               goto 20
            end if 
         end if 
 
         if (iop1.eq.1.and.(xx.gt.xmax.or.xx.lt.xmin.or.
     *             yy.gt.ymax.or.yy.lt.ymin)) goto 20

         call checkr (iop5,iop6,iop7,idr,k7,jbulk,imatch)
         if (imatch.eq.1) goto 20

30       if (ibad(i).eq.1) then 
c                                normal polygons
            call pselip (xx,yy,0.25*dcx,0.25*dcy,1.,0,0)
         else if (ibad(i).eq.2) then 
c                                unused assemblages
            call pselip (xx,yy,0.5*dcx,0.5*dcy,1.,0,7)
         else 
c                                incomplete polygons
            call pselip (xx,yy,0.25*dcx,0.25*dcy,1.,0,7)
         end if 

         call psbtxt (i,text,iend,lop)
         call pssctr (ifont,1.2*fac1,1.2*fac1,0.0)
         call pstext (xx+.7*dcx,yy+.5*dcy,text,iend)

20    continue 
 
99    if (iop5.eq.1) write (6,*) ict(1),' fields have the assemblage: ',
     *               (xnams(k,1),' ',k = 1, ixct(1))

      if (iop6.eq.1) write (6,*) ict(2),
     *               ' fields do not have any of the phases: ',
     *               (xnams(k,2),' ',k = 1, ixct(2))

      if (iop7.eq.1) write (6,*) ict(3),
     *               ' fields do have one of the phases: ',
     *               (xnams(k,3),' ',k = 1, ixct(3))

      end

c-----------------------------------------------------------------------
      subroutine psbtxt (id,string,iend,lop)

c subprogram to write a text labels for bulk composition output 

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      parameter (l3=l2+2)

      character*8 names, text(400)*1, fname*10, string*400, char*1

      integer lop(15), iwas(k5)

      common/ cst8 /names(k1)/ csta7 /fname(h9)/ phase /ikp(k1)
     *      / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)
     */ cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     */ cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     */ cst79 /prmn(k3),prmx(k3),rcps(k7),ibad(k2),icps(k7),kcx,lcx,jcx1
     */ cst81 /ptot(i8,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     */ cst82 /ptot1(i8,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)

1000  format (400a1)
1020  format (1x,f6.2,1x,a8)
1030  format (a)
2000  format (i5)
2010  format (g12.6)
2020  format (f6.2,1x,f6.2)
2030  format (a1,i2)
2040  format (g12.6,'-',g12.6)

      ist = 1
      iend = 0

      do i = 1, 400
         text(i) = ' '
      end do

      call xytopt (vtemp(1,id),vtemp(2,id),p,t,dp,dt,id)
c                                        special case for true fields only:
      if (lop(13).eq.1) then
         if (prmn(iap(id)).ne.prmx(iap(id))) then 
            write (string,2040) prmn(iap(id)),prmx(iap(id))
            iend = ist + 24
         else 
            write (string,2010) prmn(iap(id))
            iend = ist + 11
         end if 
         read (string,1000) (text(j),j=ist,iend)
         call ftext (text,ist,iend)
         ist = iend
      end if 
c                                        normal labeling:
      if (lop(1).eq.0) then 
         write (string,2000) id
         iend = ist + 4
         read (string,1000) (text(j),j=ist,iend)
         call ftext (text,ist,iend)
         ist = iend
      end if 

      if (lop(2).eq.0) then
         char = ' '
         if (lop(1).eq.0) char = '-' 
         write (string,2030) char, ivar(id)
         iend = ist + 2
         read (string,1000) (text(j), j = ist, iend)
         call ftext (text,ist,iend)
         ist = iend + 1
      else if (lop(1).eq.0) then
         ist = ist + 1
      end if 

      if (lop(3).eq.0.or.ivol.ne.0.and.lop(4).eq.0) then
         text(ist) = '('
         ist = ist + 1
      end if 

      if (lop(3).eq.0) then 
c        call rhos (rho,dp,dt,id)
         write (*,*) 'option disabled use werami/pscontor'
         stop
         write (string,2010) rho
         iend = ist + 11
         read (string,1000) (text(j), j= ist, iend)
         call ftext (text,ist,iend)
         ist = iend + 1
      end if 

      if (ivol.ne.0.and.lop(4).eq.0) then 
         write (string,2020) (wtp(jvol(i),id), i = 1, ivol)
         iend = ist + 5 + (ivol-1)*7
         read (string,1000) (text(j),j = ist, iend)
         call ftext (text,ist,iend)
      end if 

      if (lop(3).eq.0.or.ivol.ne.0.and.lop(4).eq.0) then
         text(iend) = ')'
         text(iend+1) = ' '
         iend = iend + 1
      end if 

      if (lop(6).ne.1) then 
         if (lop(4).ne.1) then 
            do i = 1, jbulk
               if (iflu(id).eq.0) then 
                  vmode = props(1,i,id)*props(4,i,id)/ptot(4,id)*1d2       
               else 
c                                   if fluid is present use 
c                                   solid-only totals:
                  vmode = props(1,i,id)*props(4,i,id)/ptot1(4,id)*1d2 
               end if 
               write (string,1020) vmode,names(idbk(i,id))
               ist = iend + 1
               iend = ist + 15
               read (string,1000) (text(j),j=ist,iend)
               call ftext (text,ist,iend)
            end do
         else if (lop(7).eq.1) then

            ict = 0

            do 10 i = 1, jbulk
               idsol = ikp(idbk(i,id))
               if (idsol.ne.0) then
                  do j = 1, ict
                     if (iwas(j).eq.idsol) goto 10 
                  end do 
                  ict = ict + 1
                  iwas(ict) = idsol
                  write (string,1030) fname(idsol)
               else
                  write (string,1030) names(idbk(i,id))
               end if 
               ist = iend + 1
               iend = ist + 11
               read (string,1000) (text(j),j=ist,iend)
               call ftext (text,ist,iend)
10          continue
         else 
            do i = 1, jbulk
               write (string,1030) names(idbk(i,id))
               ist = iend + 1
               iend = ist + 9
               read (string,1000) (text(j),j=ist,iend)
               call ftext (text,ist,iend)
            end do
         end if 
      end if 

      write (string,1000) (text(j),j=1,iend) 

      end 


      subroutine checkr (iop5,iop6,iop7,id,n,ivct,imatch)

c checkr  - subroutine to check exclusions by phase identity
c           if imatch = 0 the assemblage id matches the criteria

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      integer id(n), kex(k5+2)

      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)

      imatch = 0

      if (iop5.eq.1.or.iop6.eq.1.or.iop7.eq.1) then  

         imatch = 1

         if (iop5.eq.1) then       
            if (ivct.lt.ixct(1)) goto 99  
c                            show only with assemblage:
            itic = 0
            do 2 i = 1, ivct
c                            if you get a match then look at
c                            look for the next phase
               call checki (1,id(i),kex(i))
                  if (kex(i).ge.0) then
 
                     if (isoct.gt.0.and.kex(i).ne.0.and.
     *                              i.gt.1.and.itic.gt.0) then
                        do k = 1, i - 1
                           if (kex(k).eq.kex(i)) goto 2
                        end do 
                     end if
                     itic = itic + 1
                  end if
2           continue
c                             itic must = ixct if all phases match
            if (itic.lt.ixct(1))  goto 99
c                             if here the assemblage contains
c                             all the phases requested:
            ict(1) = ict(1) + 1
         end if

         if (iop6.eq.1) then
c                             reject fields that contain a phase:
            do j = 1, ivct
               call checki (2,id(j),itis)
               if (itis.ge.0) then
c                            name matches a phase in the field
                  ict(2) = ict(2) + 1
                  goto 99
               end if
 
            end do
c                             no match
         end if

         if (iop7.eq.1) then
            do j = 1, ivct
               call checki (3,id(j),itis)
               if (itis.ge.0) then
c                            name matches a phase in the field
                  ict(3) = ict(3) + 1
                  goto 90
               end if
            end do
c                            no match
            goto 99
         end if

90       imatch = 0 

      end if

99    end 

c--------------------------------------------------------------- 
      subroutine pspoly (fname,iop1,iop5,iop6,iop7,lop,ipoly)

c psbpts - subprogram to output bulk composition data.

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      parameter (l3=l2+2)

      real x(l5), y(l5)

      character xnams*10, yes*1, fname*100, n5name*100
 
      real scps(k7)

      integer k, lop(15), jcps(k7)
  
      common/ rxn   /vnu(k7),idr(k7),ivct,iplus(k7),iminus(k7)
     *      / excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
     *      / basic /n4,ifont,icopt,jwidth,iop0/ excl4 /xnams(50,3)
     *      / wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
     *      / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst80 /tmn(k3),tmx(k3)/ phase /ikp(k1)
     */ cst79 /prmn(k3),prmx(k3),rcps(k7),ibad(k2),icps(k7),kcx,lcx,jcx1
c----------------------------------------------------------------------
      n5 = n4 + 1
c                                    open polygon file = 'p' + plot file name.
      n5name = fname
      call inblnk (n5name,'p')
      open (n5,err=91,file=n5name,status='old')
      read (n5,*,end=91) int1, int2

      ipoly = 0 

      do i = 1, 3
         ict(i) = 0
      end do 

      do i = 1, k3
         tmn(i) = 1e30
         tmx(i) = -1e30
      end do 
c                                default fill mode by variance:
      lop(8) = 1
      if (iop0.eq.1) then 
c                                blurb
         write (*,1040)
c                                drafting options
c                                polygon fill mode:
         write (*,1010)
         read (*,1000) yes

         if (yes.eq.'y'.or.yes.eq.'Y') then
            write (*,1020)
            read (*,1000) yes
            if (yes.ne.'y'.and.yes.ne.'Y') then
c                                contour by property
               lop(8) = 2
c                                choose property
               call chsprp (lop(9),icx,jcx,jcx1,jcps,scps)
c                                get range of property
               propmn = 1e30
               propmx = -1e30

               do i = 1, ibulk
                  call getprp (vtemp(1,i),vtemp(2,i),lop(9),i,
     *                         prop,icx,jcx,jcx1,jcps,scps)
                  if (prop.lt.propmn) propmn = prop
                  if (prop.gt.propmx) propmx = prop 
               end do 

               write (*,1080) propmn,propmx
               read (*,*) pmn, dpr
               dpr = dpr - pmn

            else
c                                suppress contour by variance
               lop(8) = 0
            end if
         end if  
      end if 

      n5 = n4 + 1 

      rline = 2.
      iwidth = 0

20    read (n5,*,end=90) ipt,jpoly,ibad(jpoly),xx,yy

      vtemp(1,jpoly) = xx
      vtemp(2,jpoly) = yy

      ipr = ipt/2

      if (ipr.gt.l5*2) then
         write (*,*) 'increase l5 (pspoly) in perplex_parameters.h'
         stop
      end if
 
      read (n5,*) (x(i), y(i), i = 1, ipr)
c
      do j = 1, jbulk
         idr(j) = idbk(j,jpoly)
      end do 
c                                 get range of centroids
      jap = iap(jpoly)
      if (jap.ne.0) then
         if (xx.lt.tmn(jap)) tmn(jap) = xx
         if (xx.gt.tmx(jap)) tmx(jap) = xx
      end if 
c                                variance restriction
c      if (ivar(jpoly).gt.ivmx.or.ivar(jpoly).lt.ivmn) goto 20
 
      if (iop1.eq.1.and.(xx.gt.xmax.or.xx.lt.xmin.or.
     *          yy.gt.ymax.or.yy.lt.ymin)) goto 20

      call checkr (iop5,iop6,iop7,idr,k7,jbulk,imatch)
      if (imatch.eq.1) goto 20
 
      rline = 0.0
      iwidth = 0 

      if (lop(8).eq.0) then 
c                                          no fill
c         call pspyln (x,y,ipr,1.,1,0)

      else if (lop(8).eq.1) then 
c                                          variance based fill
         if (ivar(jpoly).eq.2) then
            call pspygn (x,y,ipr,rline,iwidth,0)
         else if (ivar(jpoly).le.7) then 
c                                          for di-septa-variant
c                                          use gray-scale
            rfill = 1. - float (ivar(jpoly)-2) * 0.2
            call pspygr (x,y,ipr,rline,iwidth,rfill)
         else 
c                                           use pattern fills
            call pspygn (x,y,ipr,rline,iwidth,1+ivar(jpoly))
         end if 
      else if (lop(8).eq.2) then 

         call getprp (vtemp(1,jpoly),vtemp(2,jpoly),lop(9),
     *                jpoly,prop,icx,jcx,jcx1,jcps,scps)

         rfill = (prop-pmn) / dpr
         if (rfill.lt.0.) then
            rfill = 0.
         else if (rfill.gt.1) then
            rfill = 1.
         end if
 
         rfill =  1. - rfill

         call pspygr (x,y,ipr,rline,iwidth,rfill)
      end if 

      goto 20
 
90    if (iop5.eq.1) write (6,*) ict(1),
     *               'fields have the assemblage: ',
     *               (xnams(k,1),' ',k = 1, ixct(1))

      if (iop6.eq.1) write (6,*) ict(2),
     *               'fields do not have any of the phases: ',
     *               (xnams(k,2),' ',k = 1, ixct(2))

      if (iop7.eq.1) write (6,*) ict(3),
     *               'fields do have one of the phases: ',
     *               (xnams(k,3),' ',k = 1, ixct(3))
c                                 find the mean centroid for each true field
      do i = 1, k3
         tmn(i) = (tmx(i) + tmn(i)) / 2.
         tmx(i) = 1e30
      end do

      goto 99 

91    ipoly = 2
      write (*,1030) n5name,fname

1000  format (a)
1010  format (/,'Change default phase field fill patterns (y/n)?',/,
     *   '  answer yes to:',/,
     *   '   - suppress default variance-based phase field patterns',/,
     *   '   - generate fills based on the value of a property')
1020  format (/,'Suppress phase field fills (y/n)? ')
1030  format (/,'The polygon file:',/,a,/,'corresponding to'
     *         ,' the plot file:',/,a,/,'Does not exist, run POLYGON'
     *         ,' to create the file.',/,'PSVDRAW will continue but'
     *         ,' false color contouring will be disabled.')
1040  format (/,'If PostScript plot file size is problematic',
     *          ' suppressing phase field',/,'fill patterns will',
     *          ' result in a major reduction file size',/)
1080  format (/,'The property ranges from: ',g12.6,'->',g12.6,/,
     *        'Enter range (min->max) of the property to be',
     *        ' contoured by false color: ')

99    close (n5)
      end

c-----------------------------------------------------------------------
      subroutine ftext (text,ist,iend)

c subprogram to filter blanks from text 

      implicit real (a-g,o-z),integer (h-n)

      character*1 text(400)

      itic = ist - 1
      igot = 0
      jend = iend 

      do 40 i = ist, iend-1

         if (text(i).eq.' '.and.text(i + 1).eq.' '.or. 
     *       text(i).eq.' '.and.text(i + 1).eq.')'.or. 
     *       text(i).eq.' '.and.text(i + 1).eq.'('.or.
     *       igot.eq.0.and.text(i).eq.' ') goto 40
         if (i.gt.ist) then
            if (text(i-1).eq.'-'.and.text(i).eq.' ') goto 40 
         end if 

         itic = itic + 1
         igot = 1
         text(itic) = text(i)

40    continue

      if (text(iend).ne.' ') then
         itic = itic + 1
         text(itic) = text(iend)
      end if 

      iend = itic + 1

      do i = iend, jend 
         text(i) = ' '
      end do 
 
      end

c--------------------------------------------------------------- 
      subroutine psgrid (iop5,iop6,iop7,lop,fac1)

c psgrid - subprogram to output bulk composition data.

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      parameter (l3=l2+2)

      character xnams*10, yes*1, text*400
 
      real scps(k7)

      integer k, lop(15), jcps(k7), iran(2,k3), jran(2,k3)
  
      common/ rxn   /vnu(k7),idr(k7),ivct,iplus(k7),iminus(k7)
     *      / cst309 /dx,dy,igrd(l7,l7),loopx,loopy
     *     / excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
     *     / basic /n4,ifont,icopt,jwidth,iop0/ excl4 /xnams(50,3)
     *     / wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
     *     / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *              iflug(k5,k2)
     *     / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *     / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *     / cst80 /tmn(k3),tmx(k3)/ phase /ikp(k1)
     */ cst79 /prmn(k3),prmx(k3),rcps(k7),ibad(k2),icps(k7),kcx,lcx,jcx1
     */ cst78 /vcpd(2,k2),icpd(k2),vpha(2,k3),ipha(k3),lex(k2)
c----------------------------------------------------------------------

c                                true phase assemblage counter
      iapmax = 0

      do i = 1, 3
         ict(i) = 0
      end do 

      do i = 1, k3
         lex(i) = 0
         iran(1,i) = l7
         iran(2,i) = 0 
         jran(1,i) = l7
         jran(2,i) = 0 
      end do 
c                                default fill mode by variance:
      lop(8) = 1
      if (iop0.eq.1) then 
c                                drafting options
c                                polygon fill mode:
         write (*,1010)
         read (*,1000) yes

         if (yes.eq.'y'.or.yes.eq.'Y') then
            write (*,1020)
            read (*,1000) yes
            if (yes.ne.'y'.and.yes.ne.'Y') then
c                                contour by property
               lop(8) = 2
c                                choose property
               call chsprp (lop(9),icx,jcx,jcx1,jcps,scps)
c                                get range of property
               propmn = 1e30
               propmx = -1e30

               do i = 1, ibulk
                  call getprp (vtemp(1,i),vtemp(2,i),lop(9),i,
     *                         prop,icx,jcx,jcx1,jcps,scps)
                  if (prop.lt.propmn) propmn = prop
                  if (prop.gt.propmx) propmx = prop 
               end do 

               write (*,1080) propmn,propmx
               read (*,*) pmn, dpr
               dpr = dpr - pmn

            else
c                                suppress contour by variance
               lop(8) = 0
            end if
         end if  
      end if 

      rline = 2.
      iwidth = 0
      x = xmin
      y = ymin

      do i = 1, loopx
         do j = 1, loopy
            jpoly = igrd(i,j)
            ipoly = iap(jpoly)
            if (ipoly.gt.iapmax) iapmax = ipoly

            vtemp(1,ipoly) = x
            vtemp(2,ipoly) = y
c
            do k = 1, jbulk
               idr(k) = idbk(k,jpoly)
            end do 
c                                 check assemblage constraints
            call checkr (iop5,iop6,iop7,idr,k7,jbulk,imatch)
            if (imatch.eq.1) then
c                                  this node won't be drawn 
               igrd(i,j) = 0
               goto 20
            end if 
c                                 flag the assemblage
            lex(ipoly) = jpoly
c                                 get range of centroids
            if (j.gt.jran(2,ipoly)) jran(2,ipoly) = j 
            if (j.lt.jran(1,ipoly)) jran(1,ipoly) = j
            if (i.gt.iran(2,ipoly)) iran(2,ipoly) = i 
            if (i.lt.iran(1,ipoly)) iran(1,ipoly) = i
 
            rline = 0.0
            iwidth = 0 
c                                  ok, we're going to draw something
            call getxy (i,j,x,y,x1,y1,x2,y2)

            if (lop(8).eq.0) then 
c                                          no fill
c               call pspyln (x,y,ipr,1.,1,0)

            else if (lop(8).eq.1) then 
c                                          strip drawing
               call watend (i,j,iend)

               if (iend.eq.0) then
c                                          at middle of strip
                  goto 20 
               else if (iend.eq.1) then 
c                                          at bottom of strip

                  x10 = x1
                  y10 = y1
                  goto 20 
               else if (iend.eq.3) then
c                                          at top of strip
                  x1 = x10
                  y1 = y10
               end if 
c                                          at top of strip, draw it
c                                          variance based fill
               if (ivar(jpoly).eq.2) then
                  call psrect (x1,x2,y1,y2,rline,iwidth,0)
               else if (ivar(jpoly).le.7) then 
c                                          for di-septa-variant
c                                          use gray-scale
                  rfill = 1. - float (ivar(jpoly)-2) * 0.2
                  call psrecr (x1,x2,y1,y2,rline,iwidth,rfill)
               else 
c                                           use pattern fills
                  call psrect (x1,x2,y1,y2,rline,iwidth,1+ivar(jpoly))
               end if 
            else if (lop(8).eq.2) then 

               call getprp (vtemp(1,jpoly),vtemp(2,jpoly),lop(9),
     *                      jpoly,prop,icx,jcx,jcx1,jcps,scps)

               rfill = (prop-pmn) / dpr
               if (rfill.lt.0.) then
                  rfill = 0.
               else if (rfill.gt.1) then
                  rfill = 1.
               end if
 
               rfill =  1. - rfill

               call psrecr (x1,x2,y1,y2,rline,iwidth,rfill)
            end if 

20          y = y + dy  

         end do 

         y = ymin
         x = x + dx

      end do 
c                                  now let's draw the edges
      x = xmin
      y = ymin

      do i = 1, loopx
         do j = 1, loopy
            jpoly = igrd(i,j)
            if (jpoly.eq.0) goto 30 
c                                  ok, we're going to draw something
            call getxy (i,j,x,y,x1,y1,x2,y2)
c                                  only draw boundaries that separate
c                                  true phase assemblages.                 
            call neebor (i,j,x1,y1,x2,y2)

            y = y + dy  

30       end do 

         y = ymin
         x = x + dx

      end do
 
      if (lop(10).ne.0) goto 90
c     if (lop(10).ne.0.or.igrd(i,j).eq.0) goto 90
c                                  last label centroids:
      do k = 1, iapmax
c                                  the assemblage doesn't occur if lex(k) = 0
c                                  but this should be possible
         if (lex(k).eq.0) cycle
c                                  guess average index
         i = (iran(1,k) + iran(2,k))/2
         if (i.eq.0) i = 1
         j = (jran(1,k) + jran(2,k))/2
         if (j.eq.0) j = 1
c                                  commented oct 1, 2004 jadc.
c         if (igrd(i,j).eq.0) cycle
c                                  test that it's ok
         jpoly = iap(igrd(i,j))

         if (jpoly.eq.iap(lex(k))) then
            x = xmin + (i-1)*dx
            y = ymin + (j-1)*dy
            ipoint = igrd(i,j)
         else 
            jpoly = iap(lex(k))
c                                  scan the range to find a node 
c                                  with the assemblage
            if (jran(2,k).gt.2) then
c                                  first try to find one at an i-value 
c                                  at half the j-range
               jj = jran(2,k)/2
               do ii = iran(1,k), iran(2,k)
                  if (iap(igrd(ii,jj)).eq.jpoly) then
                     ipoint = igrd(ii,jj)
                     x = xmin + (ii-1)*dx
                     y = ymin + (jj-1)*dy
                     goto 50
                  end if 
               end do 
            end if 

            if (iran(2,k).gt.2) then 
c                                  next try to find one at an j-value 
c                                  at half the i-range
               ii = iran(2,k)/2
               do jj = jran(1,k), jran(2,k)
                  if (iap(igrd(ii,jj)).eq.jpoly) then
                     ipoint = igrd(ii,jj)
                     x = xmin + (ii-1)*dx
                     y = ymin + (jj-1)*dy
                     goto 50
                  end if 
               end do 
            end if 
c                                  last try, scan the range to find a node 
c                                  with the assemblage
            do ii = iran(1,k), iran(2,k)
               do jj = jran(1,k), jran(2,k)
                  if (iap(igrd(ii,jj)).eq.jpoly) then
                     ipoint = igrd(ii,jj)
                     x = xmin + (ii-1)*dx
                     y = ymin + (jj-1)*dy
                     goto 50
                  end if 
               end do 
            end do 
c                                   no grid point found for the 
c                                   assemblage, perhaps the resetting of
c                                   igrd to zero allows this?
            write (*,*) 'uh-oh on assemblage', jpoly
            goto 40

         end if 
c                                   call label routine:
50       call pselip (x,y,0.25*dcx,0.25*dcy,1.,0,0) 
         call psbtxt (ipoint,text,iend,lop)
         call pssctr (ifont,1.2*fac1,1.2*fac1,0.0)
         call pstext (x+.7*dcx,y+.5*dcy,text,iend)

40    end do 
 
90    if (iop5.eq.1) write (6,*) ict(1),
     *               'fields have the assemblage: ',
     *               (xnams(k,1),' ',k = 1, ixct(1))

      if (iop6.eq.1) write (6,*) ict(2),
     *               'fields do not have any of the phases: ',
     *               (xnams(k,2),' ',k = 1, ixct(2))

      if (iop7.eq.1) write (6,*) ict(3),
     *               'fields do have one of the phases: ',
     *               (xnams(k,3),' ',k = 1, ixct(3))


1000  format (a)
1010  format (/,'Change default phase field fill patterns (y/n)?',/,
     *   '  answer yes to:',/,
     *   '   - suppress default variance-based phase field patterns',/,
     *   '   - generate fills based on the value of a property')
1020  format (/,'Suppress phase field fills (y/n)? ')
1080  format (/,'The property ranges from: ',g12.6,'->',g12.6,/,
     *        'Enter range (min->max) of the property to be',
     *        ' contoured by false color: ')

99    end

c--------------------------------------------------------------- 
      subroutine getxy (i,j,x,y,x1,y1,x2,y2)

c getxy - get coordinates for grid node volume

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      common/ cst309 /dx,dy,igrd(l7,l7),loopx,loopy

      if (i.gt.1.and.i.lt.loopx.and.j.gt.1.and.j.lt.loopy) then

         x1 = x - 0.5*dx
         x2 = x + 0.5*dx
         y1 = y - 0.5*dy
         y2 = y + 0.5*dy
         goto 99
      end if 
c                                         on an edge:
      if (j.eq.loopy) then 
         y2 = y
         y1 = y - 0.5*dy
      else if (j.eq.1) then 
         y1 = y
         y2 = y + 0.5*dy
      else 
         y1 = y - 0.5*dy
         y2 = y + 0.5*dy
      end if 

      if (loopx.eq.1) then 
         x1 = x
         x2 = x + 0.5*dx
      else if (i.eq.loopx) then 
         x1 = x - dx*0.5
         x2 = x
      else if (i.eq.1) then 
         x1 = x
         x2 = x + 0.5*dx
      else 
         x1 = x - 0.5*dx
         x2 = x + 0.5*dx
      end if 

99    end 

c--------------------------------------------------------------- 
      subroutine neebor (i,j,x1,y1,x2,y2)

c neebor - check, which, if any adjacent grid points have
c a different phase assmblage.

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      common/ cst309 /dx,dy,igrd(l7,l7),loopx,loopy
     *      / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)

      rline = 1.
      iwidth = 1
      i0 = iap(igrd(i,j))

      if (i.eq.1) then
         im1 = i0
      else if (igrd(i-1,j).eq.0) then 
         im1 = 0
      else
         im1 = iap(igrd(i-1,j))
      end if

      if (i.eq.loopx) then 
         ip1 = i0
      else if (igrd(i+1,j).eq.0) then 
         ip1 = 0
      else
         ip1 = iap(igrd(i+1,j))
      end if  

      if (j.eq.1) then 
         jm1 = i0
      else if (igrd(i,j-1).eq.0) then 
         jm1 = 0
      else
         jm1 = iap(igrd(i,j-1))
      end if 

      if (j.eq.loopy) then 
         jp1 = i0
      else if (igrd(i,j+1).eq.0) then 
         jp1 = 0
      else
         jp1 = iap(igrd(i,j+1))
      end if 
                          
      if (i.ne.1.and.im1.ne.i0) 
     *    call psline (x1,y1,x1,y2,rline,iwidth)
      if (j.ne.loopy.and.jp1.ne.i0)
     *    call psline (x1,y2,x2,y2,rline,iwidth)
      if (i.ne.loopx.and.ip1.ne.i0) 
     *    call psline (x2,y1,x2,y2,rline,iwidth)
      if (j.ne.1.and.jm1.ne.i0) 
     *    call psline (x1,y1,x2,y1,rline,iwidth)

      end 


c--------------------------------------------------------------- 
      subroutine watend (i,j,iend)

c watend - check, which, if any adjacent grid points have
c a different phase assmblage.

c    iend = 0, no edges are ends
c    iend = 1, bottom edge is an end
c    iend = 2, both edges are ends
c    iend = 3, top edge is an end

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      common/ cst309 /dx,dy,igrd(l7,l7),loopx,loopy
     *      / cst74  /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)

      i0 = iap(igrd(i,j))

      if (j.eq.loopy) then
         ijp1 = iap(igrd(i,j))
      else if (igrd(i,j+1).ne.0) then 
         ijp1 = iap(igrd(i,j+1))
      else 
         ijp1 = 0
      end if 

      if (j.eq.1) then 
         ijm1 = iap(igrd(i,j))
      else if (igrd(i,j-1).ne.0) then 
         ijm1 = iap(igrd(i,j-1))
      else 
         ijm1 = 0
      end if 

      if (j.eq.1) then 
         iend = 1
         if (i0.ne.ijp1) then 
            iend = 2
         end if 
      else if (j.eq.loopy) then
         iend = 3
         if (i0.ne.ijm1) then 
            iend = 2
         end if 
      else if (i0.ne.ijp1.and.i0.ne.ijm1) then 
         iend = 2
      else if (i0.ne.ijm1) then 
         iend = 1
      else if (i0.ne.ijp1) then 
         iend = 3
      else 
         iend = 0
      end if 
                          
      end 